{
> I would like to include a clock in my current project which will be
> updated once a minute.  Instead of constantly checking the computer's clock
> and waiting for it to change, I would like to use an interrupt.

This one has even a hot key handler.  If you want to update it once per
minute, bump a counter within the interrupt 1Ch handler till it reaches the
value 60*18.2.  Then refresh the screen.
}

Program Clock;

{ G+,R-,S-,M 1024, 0, 0 }
{$G+,R-,S-,M 16000,5024,5024 }

uses
  Dos,Crt;

Const
  x           = 0;                   { x location on screen }
  y           = 1;                    { y location on screen }
  Keyboard    = 9;                    { Hardware keyboard interrupt }
  TimerTick   = $1C;                  { Gets called 18.2 / second }
  VideoOffset = 160 * (y - 1) + 2 * x;{ Offset in display memory }
  yellow      = 14;
  blue        = 1;
{ attribute   = blue * 16 + yellow;   { Clock colours }
  attribute   = black* 16 + 7  ;   { Clock colours }
  VideoBase   : Word = $B800;         { Segment of display memory }
  ActiveFlag  : ShortInt = -1;        { 0: on, -1: off }

Var
  OrgInt9,                             { Saved interrupt 9 vector }
  OrgInt10h,
  OrgInt1Ch : Pointer;              { Saved interrupt 1Ch vector }
  VideoMode : Byte absolute $0000:$0449;
  fseg,fofs:word;
  rijtje:array[0..7] of byte;
  rijnr:word;
  zoekwoord,zoekwoord2:string[10];
  zoekwoordlen:word;
  intercept_do_it:word;

  cntr,cntr2,cntr3,cntr4,cntr5:word;

  zoekwoord_aktief:word;
  Logpos:word;
  Log:array[0..255] of byte;
  Log_ASCII:array[0..255] of byte;
  filename: string;
  binfile : file of byte;
{ Display a string using Dos services (avoid WriteLn, save memory) }
Var
  OLD_29H :Pointer;
  C   :char;         { Holds Charactor to Write }
  Cb  :byte;         { Holds Charactor to Write }
  c_extra:byte;
  c_extra2:byte;
  whx,why:integer;
  whxcurs,whycurs:integer;
  whxcurs_prev,whycurs_prev:integer;
Var
  newCharset,
  oldCharset : Array[0..255,1..16] of Byte;
  fontje,textmodebuffer:pointer;
  tick:word;
{$F+}
{
Procedure NewInt29(Flags, CS, IP, AX, BX, CX, DX, SI, DI, DS, ES, BP: Word);
Interrupt;
begin
  VioBuffer^[YVio, XVio].Attr := VioBuffer^[YVio, XVio].Attr And Not 112;
  if (Lo(AX) = 13) Then
  begin
    XVio := X1;
    AX := 0;
  end
  else
  if (Lo(AX) = 10) Then
  begin
    Inc(YVio);
    AX := 0;
  end;
  begin
    if (XVio > X2) Then
    begin
      XVio := X1;
      Inc(YVio);
    end;
    if (YVio > Y2) Then
    begin
      Asm
        Mov   AH, 06
        Mov   AL, YVio
        Sub   AL, Y2
        Mov   CH, Y1
        Mov   CL, X1
        Mov   DH, Y2
        Mov   DL, X2
        Mov   BH, 07
        Int   10h
      end;

      YVio := Y2;
    end;

    if (Lo(AX) = 32) Then
    begin
      if (Lo(VioCurLoc) < XVio) Then
      begin
        XVio := Lo(VioCurLoc);
        VioBuffer^[YVio, XVio].Ch := Lo(AX);
      end
      else
      begin
        VioBuffer^[YVio, XVio].Ch := Lo(AX);
        Inc(XVio);
      end;
    end
    else
    begin
      VioBuffer^[YVio, XVio].Ch := Lo(AX);
      Inc(XVio);
    end;
    VioCurLoc := YVio Shl 8 + XVio;
  end;
  VioBuffer^[YVio, XVio].Attr := VioBuffer^[YVio, XVio].Attr Or 112;
end;
{$F-}
procedure setmode (mode : word); assembler;
asm
  mov ax,4F02h
  mov bx,mode
  int 10h
end;
procedure SetGraphics(Mode : byte); assembler;
asm mov AH,0;mov AL,Mode;int 10h;end;
procedure setpal(c,r,g,b:byte); assembler; asm
  mov dx,3c8h; mov al,[c]; out dx,al; inc dx; mov al,[r]
  out dx,al; mov al,[g]; out dx,al; mov al,[b]; out dx,al; end;
procedure nextline;
var
  cntr_loc:word;
begin
  inc(why);
  if why>24 then begin
    why:=24;
    for cntr_loc:=0 to 80*24-1 do memw[Videobase:cntr_loc shl 1]:=memw[Videobase:cntr_loc shl 1+160];
{   for cntr_loc:=0 to 80-1 do memw[Videobase:cntr_loc shl 1+12*160]:=0;}
    for cntr_loc:=0 to 80-1 do memw[Videobase:cntr_loc shl 1+24*160]:=0;
  end;
end;
procedure nextline_swap;
var
  cntr_loc:word;
begin
  inc(why);
  if why>24 then begin
    why:=24;
    for cntr_loc:=80*24-1 downto 0 do memw[Videobase:cntr_loc shl 1+160]:=memw[Videobase:cntr_loc shl 1];
{   for cntr_loc:=0 to 80-1 do memw[Videobase:cntr_loc shl 1]:=0;}
  end;
end;
procedure mark_patch;
interrupt;
begin
  asm
{   STI
    CLI}
    PUSHF
    CALL  DWord Ptr [OrgInt10h]
  end;
end;

Procedure Patch1;
Interrupt;
Begin
  asm
    sti
  end;
  cb:=ORD(c);
  whx:=wherex-1;
  why:=wherey-1;
  if cb=13 then whx:=0;
  if cb=10 then nextline;
  if (cb<>13) AND (cb<>10) then begin
{   memw[Videobase:(79-whx)*2+(why)*160]:=attribute shl 8+cb;}
    memw[Videobase:whx*2+why*160]:=attribute shl 8+cb;
    inc(whx);
    if whx>80 then begin
      whx:=0;
      nextline;
    end;
  end;
  asm
    cli
  end;
{ if why>24 then why:=24;}
  GOTOXY(whx+1,why+1);
End;
Procedure getoldCharset;
Var
  b : Byte;
  w : Word;
begin
  For b := 0 to 255 do
  begin
    w := b * 32;
    Inline($FA);
    PortW[$3C4] := $0402;
    PortW[$3C4] := $0704;
    PortW[$3CE] := $0204;
    PortW[$3CE] := $0005;
    PortW[$3CE] := $0006;
    Move(Ptr($A000, w)^, oldCharset[b, 1], 16);
    PortW[$3C4] := $0302;
    PortW[$3C4] := $0304;
    PortW[$3CE] := $0004;
    PortW[$3CE] := $1005;
    PortW[$3CE] := $0E06;
    Inline($FB);
  end;
end;
Procedure setasciiChar(Charnum : Byte; Var data);
Var
  offset : Word;
begin
  offset := CharNum * 32;
  Inline($FA);
  PortW[$3C4] := $0402;
  PortW[$3C4] := $0704;
  PortW[$3CE] := $0204;
  PortW[$3CE] := $0005;
  PortW[$3CE] := $0006;
  Move(data, Ptr($A000, offset)^, 16);
  PortW[$3C4] := $0302;
  PortW[$3C4] := $0304;
  PortW[$3CE] := $0004;
  PortW[$3CE] := $1005;
  PortW[$3CE] := $0E06;
  Inline($FB);
end;

Procedure Patch; Assembler;
  Asm
    Push DS
    Push Ax
        Mov   AX, Seg C;
        Mov   DS, AX;
        Pop   AX;
        Mov   C, Al;
        Mov   C_extra, dh;
        Pop   DS
        Jmp   Patch1;
  End;

procedure retrace; assembler; asm
  mov dx,3dah; @vert1: in al,dx; test al,8; jz @vert1
  @vert2: in al,dx; test al,8; jnz @vert2; end;
procedure _25lines; assembler;
asm
  mov ax,83h {83h}
  int 10h
end;
procedure _50lines; assembler;
asm
  mov ax,1202h
  mov bl,30h
  int 10h
  mov ax,1112h
  mov bl,0
  int 10h
end;

Procedure DisplayString(s : String); Assembler;

ASM
  PUSH   DS
  XOR    CX, CX
  LDS    SI, s
  LODSB
  MOV    CL, AL
  JCXZ   @EmptyString
  CLD
 @NextChar:
  LODSB
  XCHG   AX, DX
  MOV    AH, 2
  INT    21h
  LOOP   @NextChar
 @EmptyString:
  POP    DS
end;
procedure writestring(str:string;x,y:word);
var
  cntr_loc:word;
begin
  for cntr_loc:=1 to length(str) do mem[Videobase:cntr_loc shl 1+(80*2*y)+x*2]:=ord(str[cntr_loc]);
end;

{ Returns True if a real time clock could be found }
Function HasRTClock : Boolean; Assembler;

ASM
  XOR    AL, AL
  MOV    AH, 2
  INT    1Ah
  JC     @NoRTClock
  INC    AX
 @NoRTCLock:
end;

{ Release Dos environment }
Procedure ReleaseEnvironment; Assembler;
ASM
  MOV    ES, [PrefixSeg]
  MOV    ES, ES:[002Ch]
  MOV    AH, 49h
  INT    21h
end;
{ Convert a packed BCD byte to ASCII character }
Procedure Digit; Assembler;
ASM
  PUSH   AX
  CALL   @HiNibble
  POP    AX
  CALL   @LoNibble
  RETN

 @HiNibble:
  SHR    AL, 4
  JMP    @MakeAscii
 @LoNibble:
  AND    AL, 0Fh
 @MakeAscii:
  OR     AL, '0'
  STOSW
end;
{ Convert a packed BCD byte to ASCII character }
{const
  hex:array[0..15] of char=('0','1','2','3','4','5','6','7','8',
                            '9','A','B','C','D','E','F');}
Procedure Digit_big; Assembler;
ASM
  jmp @skip
 @hex:db '0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'
 @skip:
{ xor bx,bx
  mov bl,dh
  and bl,$f0;
  shr bl,4
  mov al,cs:[offset @hex+bx]
  stosw
  mov bl,dh
  and bl,$0f;
  mov al,cs:[offset @hex+bx]
  stosw}
  mov bl,dl
  and bl,$f0;
  shr bl,4
  mov al,cs:[offset @hex+bx]
  stosw
  mov bl,dl
  and bl,$0f;
  mov al,cs:[offset @hex+bx]
  stosw
end;

procedure Interceptions;
var
  K:byte;
begin
  intercept_do_it:=0;
  k:=0;
  repeat
    setpal(0,k,0,0);
    retrace;
    k:=(k+1) AND 63;
  until k=80;
end;

{ INT 9 handler intercepting Alt-F11 }
Procedure ToggleClock; Interrupt; Assembler;
var
  key:byte;
Const
  F11      = $57;                  { 'F11' make code }
  BiosSeg  = $40;                  { Segment of BIOS data area }
  AltMask  = $08;                  { Bitmask of Alt key }
  KbdFlags = $17;                  { Byte showing keyboard status }

  break_key= $46; {was $46}

ASM
  STI
  IN     Al, 60h  {al}
  mov key,al


  pusha


  CMP    [ActiveFlag], 0
  JNE    @Exit2

{update rijtje}
  mov bx,rijnr
  mov al,key
  mov ds:[offset rijtje+bx],al
  inc bx      {volgende rijnr}
  and bx,7
  mov rijnr,bx

{print rijtje}
  mov cx,rijnr
  MOV ES, [VideoBase]
  MOV DI, VideoOffset
  add di,(80-2)*2{+(80)*2*16}
@loop:
  mov si, offset rijtje
  add si,cx
  mov al,ds:[si]
  MOV AH, attribute {!}

  mov dx,ax  {alles in dx meegeven}
  call digit_big

  add di,(80-2)*2 {volgende regel op scherm}
  inc cx     {volgende in rijtje}
  cmp cx,8
  jne @niet8
  mov cx,0
 @niet8:
  cmp cx,rijnr
  jne @loop
 @Exit2:


  popa


 { F11 pressed? }
  CMP    AL, F11
  JNE    @PassThru

 { Alt-key pressed? }
  PUSH   BiosSeg
  POP    ES
  MOV    AL, ES:[KbdFlags]
  AND    AL, AltMask
  CMP    AL, AltMask
  JNE    @PassThru

 { Flip status flag, force EOI and leave routine }
  mov intercept_do_it,$ffff;
  and    [ActiveFlag],0
  IN     AL, 61h
  MOV    AH, AL
  OR     AL, 80h
  OUT    61h, AL
  MOV    AL, AH
  OUT    61h, AL
  CLI
  MOV    AL, 20h
  OUT    20h, AL
  STI
  JMP    @Exit

 @PassThru:
  CLI
  PUSHF
  CALL   DWord Ptr [OrgInt9]
 @Exit:
end;  { ToggleClock }

procedure getfont; assembler; asm
  mov ax,1130h; mov bh,6; int 10h; mov fseg,es; mov fofs,bp; end;
procedure writetxt(x,y:word; txt:string);
var i,j,k:byte;
begin
  for i:=1 to length(txt) do for j:=0 to 15 do for k:=0 to 7 do
    if ((mem[fseg:fofs+ord(txt[i])*16+j] shl k) and 128) <> 0 then begin
      mem[$a000:(y+j)*320+((i-1)*8)+x+k]:=63;
    end;
end;

procedure naar_VGA;
begin
  asm
    Mov AX,93h; {13h}
    Int 10h  { Go_Grafix_Mode 320x200x256}
  end;
{ Directvideo:=false;}
end;

procedure plasmatic;
var
  cntr,cntr2:word;
  val:byte;
begin
  setpal(0,16,16,16);
  setpal(63,63,63,63);
  for cntr2:=0 to 80 do begin
    for cntr:=0 to 319 do begin
      val:=mem[$a000:cntr+cntr2 shl 6+cntr2 shl 8];
      if (val=0) OR (val>63) then mem[$a000:cntr+cntr2 shl 6+cntr2 shl 8]:=(cntr+cntr2) AND 15+128;
    end;
  end;
end;
{ INT 1Ch handler that displays a clock on the right hand side of the screen }
(*
Procedure DisplayClock; Interrupt;
begin
ASM
  CMP    [ActiveFlag], 0
  JNE    @Exit
  CLD
  MOV    AH, 2
  INT    1Ah
  MOV    ES, [VideoBase]
  MOV    DI, VideoOffset
  add    di,69*2  {70 karakters naar rechts}
  MOV    AH, attribute {!}
  MOV    AL, CH
  CALL   Digit
  MOV    AL, ':'
  STOSW
  MOV    AL, CL
  CALL   Digit
  MOV    AL, ':'
  STOSW
  MOV    AL, DH
  CALL   Digit         {!}
  MOV    AL, ' '
  STOSW

  PUSHF
  CALL   DWord Ptr [OrgInt1Ch]
 @Exit:
end;
end;*)
procedure setbank(bank:word);assembler;
asm
  mov ax, 4f05h
  mov bx, 0h
  mov dx, bank
  mov Bank, dx
  int 10h
end;
Procedure DisplayClock; Interrupt;
var
  cntr_loc,cntr_loc2:word;
  cntr_locx,cntr_locy:word;
  chr_loc:word;
  horchr_loc:byte;
  offset_loc:word;
  curr_bank_loc:word;
  overbank:boolean;
begin
  inc(tick,1);
  if tick=5 then begin
    tick:=0;
    ASM
      CLD
    end;
    setpal(0,16,16,16);
    for cntr:=0 to 24 do setpal(64+cntr,63,63-cntr*63 DIV 14,63);
(*  for cntr_locy:=0 to 11 do begin
      for cntr_locx:=0 to 79 do begin
        offset_loc:=cntr_locx*7+cntr_locy*8*640;
        chr_loc:=memw[Videobase:cntr_locx*2+cntr_locy*160] and 255;

        for cntr_loc2:=0 to 7 do begin
          horchr_loc:=newcharset[chr_loc,cntr_loc2+1];
          for cntr_loc:=0 to 5 do begin
            if (horchr_loc AND 128)=128 then begin
              mem[$a000:offset_loc]:=cntr_loc+cntr_loc2+64;
            end else begin
              mem[$a000:offset_loc]:=0;
            end;
            horchr_loc:=horchr_loc shl 1;
            inc(offset_loc);
          end;
          inc(offset_loc,640-6);
        end;

      end;
    end;
*)
    curr_bank_loc:=0;
    setbank(curr_bank_loc);
    for cntr_locy:=0 to 24 do begin
      for cntr_loc2:=0 to 7 do begin
        offset_loc:=(cntr_locy*8+cntr_loc2)*640;
        if ((offset_loc+640) AND 65536)<offset_loc then overbank:=true;

        if overbank=true then begin
          for cntr_locx:=0 to 79 do begin
            chr_loc:=memw[Videobase:cntr_locx*2+cntr_locy*160] and 255;
            horchr_loc:=newcharset[chr_loc,cntr_loc2+1];
            for cntr_loc:=0 to 5 do begin
              if (horchr_loc AND 128)=128 then begin
                mem[$a000:offset_loc]:=cntr_loc+cntr_loc2+64;
              end else begin
                mem[$a000:offset_loc]:=0;
              end;
              horchr_loc:=horchr_loc shl 1;
              inc(offset_loc);
              if offset_loc=0 then begin
                inc(curr_bank_loc);
                setbank(curr_bank_loc);
              end;
            end;
            inc(offset_loc,1);
              if offset_loc=0 then begin
                inc(curr_bank_loc);
                setbank(curr_bank_loc);
              end;
            inc(offset_loc,1);
              if offset_loc=0 then begin
                inc(curr_bank_loc);
                setbank(curr_bank_loc);
              end;
          end;
        end else begin
          for cntr_locx:=0 to 79 do begin
            chr_loc:=memw[Videobase:cntr_locx*2+cntr_locy*160] and 255;
            horchr_loc:=newcharset[chr_loc,cntr_loc2+1];
            for cntr_loc:=0 to 5 do begin
              if (horchr_loc AND 128)=128 then begin
                mem[$a000:offset_loc]:=cntr_loc+cntr_loc2+64;
              end else begin
                mem[$a000:offset_loc]:=0;
              end;
              horchr_loc:=horchr_loc shl 1;
              inc(offset_loc);
            end;
            inc(offset_loc,2);
          end;
        end;
{       inc(offset_loc,640-6);}
      end;
    end;
  end;
  asm
    PUSHF
    CALL   DWord Ptr [OrgInt1Ch]
  end;
end;

Begin
  getmem(textmodebuffer,4000);
  write(c);
  whx:=wherex;
  why:=wherey;
  If VideoMode = 7 Then
    VideoBase := $B000;
  VideoBase:=SEG(Textmodebuffer^);
  getoldcharset;
  for cntr3:=0 to 255 do begin
    for cntr2:=0 to 15 do begin
      newcharset[cntr3,cntr2+1]:=0;
    end;
    for cntr2:=0 to 15 do begin
      cntr5:=cntr2*9 DIV 15;
      for cntr:=0 to 7 do begin
        cntr4:=cntr*5 DIV 7+(7-5);
        newcharset[cntr3,cntr5+1]:=newcharset[cntr3,cntr5+1] OR
                     (((oldcharset[cntr3,cntr2+1] shr cntr) AND 1) shl cntr4);
      end;
    end;
{
    for cntr2:=0 to 7 do begin
      for cntr:=0 to 5 do begin
        if ((newcharset[cntr3,cntr2+1] shl cntr) AND 128)=128 then begin
          mem[SEG(fontje^):cntr+cntr2*6+cntr3*6*8]:=cntr+cntr2+64;
        end else begin
          mem[SEG(fontje^):cntr+cntr2*6+cntr3*6*8]:=0;
        end;
      end;
    end;}
  end;
  rijnr:=0;
  tick:=0;
  for cntr:=0 to 3999 do mem[videobase:cntr]:=0;
  setmode($101);{640x480x256}
  directvideo:=true;
  GetIntVec(TimerTick, OrgInt1Ch);
  SetIntVec(TimerTick, @DisplayClock);
  GetIntVec(Keyboard, OrgInt9);
  SetIntVec(Keyboard, @ToggleClock);
  GetINtVec($29, OLD_29H);
  SetIntVec($29, @Patch);
{ GetINtVec($10, OrgInt10H);
  SetIntVec($10, @new_int10h);}

  SwapVectors;
  ReleaseEnvironment;
  DisplayString('CLOCK installed.  <Alt-F11> toggles on/off');
  Keep(0);
end.
