program Julia_fractal;
uses crt;

const
  xcent=160;
  ycent=100;
  xsize=320;
  ysize=200;
  Zmax=160; {160}
  iteraties=50;
  filename='D:\turbo\units\julia.8rw';
{ Julia_file=false;}
  Julia_file=true;
  dieptekijken=160; {128}
  breedtekijken=128;{128}
var
  Ar,Ai,Br,Bi,A1,A2,B1,B2,XC,YC,DELH,DELV,BH:real;
  N1,N2:integer;
  i,j,k,l,xm,ym:integer;
  x,y,s:real;
  x3,y3:real;
  {ml_mem,}juliamem,transmem:pointer;
  angle:word;
  Xricoarr,Yricoarr:array[0..xsize-1] of integer;
  Xcam,Ycam:integer;  {256e precisie}
  Xcamspeed,Ycamspeed,anglespeed:integer;
  sourceseg,sourceofs,transseg:word;
  quit:boolean;
  key:char;
  maal,maal2:integer;
  cntr:word;
  myval:longint;
  fseg,fofs:word;
  bigcntr,bigcntr2,bigcntr3:word;

{----------------------------------------------------------------------------}
procedure getfont; assembler; asm
  mov ax,1130h; mov bh,6; int 10h; mov fseg,es; mov fofs,bp; end;
procedure writetxt(x,y:word; txt:string);
var i,j,k:byte;
begin
  for i:=1 to length(txt) do for j:=0 to 15 do for k:=0 to 7 do
    if ((mem[fseg:fofs+ord(txt[i])*16+j] shl k) and 128) <> 0 then begin
      mem[$a000:(y+j)*320+(i*8)+x+k]:=255;
    end;
end;

procedure retrace;
begin
  while (port[$3da] and 8) <> 8 do;
  while (port[$3da] and 8) = 8 do;
end;
procedure Setcol(cnr,r,g,b:byte);
begin
  port[$3c8]:=cnr;
  port[$3c9]:=r;
  port[$3c9]:=g;
  port[$3c9]:=b;
end;

procedure SetGraphics;
var GrMd,GrDr : integer;
{$F+} function DetectVGA : Integer; begin DetectVGA := 2; end; {$F-}
begin
  asm mov AH,0;mov AL,13h;int 10h;end;
  DirectVideo:=False;           { WriteLn works in GrafiX mode Now }
end;
procedure SetPal;
var
  cntr:word;
begin
  for cntr:=0 to 7 do SetCol(cntr+1     ,cntr*4 ,0,32);
  for cntr:=0 to 15 do
    begin
                      SetCol(cntr+8+1   ,cntr*2+32,0,32-cntr*2);
                      SetCol(cntr+8+16+1,63,cntr*2,0);
                      SetCol(cntr+8+32+1,63,cntr*2+32,0);
  end;
end;
procedure SetPalGrey;
var
  cntr:word;
begin
  for cntr:=1 to 63 do
    begin
{     SetCol(cntr,random(64),random(64),random(64));}
      SetCol(cntr,cntr,cntr,cntr);
  end;
{112 COLORS}
{ for cntr:=0 to 31 do begin
    SetCol(cntr+1,cntr,0,0);
    SetCol(cntr+33,32+cntr,0,cntr);
    SetCol(cntr+65,63,cntr,32+cntr);
    SetCol(cntr+97,63,32+cntr,63);
  end;}
{160 COLORS}
{
  for cntr:=0 to 31 do begin
    SetCol(cntr+1  ,0      ,0      ,cntr DIV 2  );
    SetCol(cntr+33 ,cntr   ,0      ,16+cntr DIV 2);
    SetCol(cntr+65 ,32+cntr,cntr   ,32+cntr DIV 2);
    SetCol(cntr+97 ,63     ,32+cntr,48-cntr DIV 2);
    SetCol(cntr+129,63     ,63     ,32+cntr );
  end;
}
{160 COLORS}

  for cntr:=0 to 31 do begin
    SetCol(cntr+1  ,cntr DIV 2   ,0      ,0      );
    SetCol(cntr+33 ,16+cntr DIV 2,0      ,0      );
    SetCol(cntr+65 ,32+cntr DIV 2,cntr   ,0      );
    SetCol(cntr+97 ,48+cntr DIV 2,32+cntr,cntr   );
    SetCol(cntr+129,63           ,63     ,32+cntr);
  end;

end;
procedure ResetGraphics;
begin
  asm mov AH,0;mov AL,03h;int 10h;end;
end;
{----------------------------------------------------------------------------}
procedure Calc_Angle;
var
  x:longint;
  Xvect,Yvect:real;
  Xrico,Yrico:longint;
  sin1,cos1,sin2,cos2:real;
begin
  sin1:=SIN(angle*pi/1024)*100*dieptekijken;
  cos1:=COS(angle*pi/1024)*100*dieptekijken;
  sin2:=SIN((angle+512)*pi/1024)*breedtekijken;
  cos2:=COS((angle+512)*pi/1024)*breedtekijken;
    for x:=0 to xsize-1 do begin
      Xvect:=(sin1+sin2*(x-xcent));
      Yvect:=(cos1+cos2*(x-xcent));
      mem[$a000:(((trunc(Xvect) shr 8+Xcam) and 255) shr 2)
               +(((trunc(Yvect) shr 8+Ycam) and 255) shr 2+130)*320]:=angle;
      Xrico:=trunc(Xvect*2/Zmax);
      Yrico:=trunc(Yvect*2/Zmax);
      Xricoarr[x]:=Xrico;
      Yricoarr[x]:=Yrico;
    end;
      mem[$a000:((Xcam AND 255) shr 2)
               +((Ycam AND 255) shr 2+130)*320]:=255;
end;
procedure  Calc_Julia;
var
  f:file of byte;
label
  l270;
begin
  Ar:=-0.57695;
  Ai:=0.175;
  Br:=0.8;
  Bi:=0;
  Bh:=0.5;
  A1:=3*(AR*AR-AI*AI);
  A2:=6*AR*AI;
  B1:=BR;
  B2:=BI;
  XC:=-0.14;
  YC:=0;
  DELH:=1.7/1.1;
  DELV:=1.2/1.1;
  N1:=128;
  N2:=128;
  FOR I:=-128 to 127 do begin
    for j:=-127 to 128 do begin
      X:=XC+i*DELH/N1;
      Y:=YC+j*DELV/N2;
      for K:=0 to iteraties do begin  {AANTAL ITERATIES ,WAS 100}
        S:=X*X+Y*Y;
        if S>1000 then begin
          L:=K;
          GOTO l270
        end;
        x3:=X*(X*X-J*Y*Y)-A1*X+A2*y+B1;
        y3:=Y*(3*X*X-Y*Y)-A1*Y-A2*X+B2;
        if ((X-X3)*(X-X3)+(Y-Y3)*(Y-Y3))<0.0001 then begin
          l:=K;
          GOTO l270
        end;
        X:=X3;
        Y:=Y3;
      end;
      L:=iteraties+1;
      l270:
      mem[$a000:(128+I)+((128-J) DIV 2)*320]:=127-l;
      mem[SEG(juliamem^):(128+I)+(128-J)*256]:=127-l;
    end;
  end;
  assign(f,filename);
  rewrite(f);
{ blockwrite(f,juliamem^,65535);}
  for cntr:=0 to 65535 do begin
    write(f,mem[SEG(juliamem^):cntr]);
  end;
  close(f);
end;
procedure load_Julia;
var
  f:file;
begin
  for maal:=0 to 32767 do begin
    memw[SEG(juliamem^):maal*2]:=127+127*256;
  end;
  assign(f,filename);
  reset(f);
  blockread(f,juliamem^,65535);
  for maal:=0 to 255 do begin
    mem[SEG(juliamem^):maal]:=       127-10;
    mem[SEG(juliamem^):maal*256]:=   127-10;
    mem[SEG(juliamem^):maal+256]:=   127-10;
    mem[SEG(juliamem^):maal*256+1]:= 127-10;
  end;
  close(f);
end;
procedure Draw_3d;
var
  X,Z:word;
  prev_height:word;
  calloffset:word;
  Xrico,Yrico,Prec_Xrico,Prec_Yrico:byte;
  Ztrans:word;
begin
  sourceseg:=SEG(juliamem^);
  transseg:=SEG(transmem^);
  asm
  mov si,offset @mlcode+3
  mov ax,0
  mov cx,200
@loopie:
  mov cs:[si],ax
  add si,5
  add ax,320
  dec cx
  jnz @loopie



  mov ax,sourceseg  {SOURCE}
  mov es,ax
  mov ax,transseg
 {mov fs,ax} db $8E,$E0
  mov di,0
{  mov ax,cs:[offset @na_jmp-2]}
  mov ax,offset @mlcode
  sub ax,offset @na_jmp
  mov calloffset,ax
  mov x,0

  @loop1:

    mov bx,199*5  {Door 'strech Z and *5'-tabel halen}
    mov prev_height,bx

    {haal rico op}
    mov dl,ds:[di+offset Xricoarr]+1
    mov Xrico,dl
    mov al,ds:[di+offset Xricoarr]
    mov Prec_Xrico,al
    mov dh,ds:[di+offset Yricoarr]+1
    mov Yrico,dh
    mov cl,ds:[di+offset Yricoarr]
    mov Prec_Yrico,cl
    mov bl,ds:[offset Xcam]
    mov bh,ds:[offset Ycam]
    xor al,al
    xor ah,ah
    {gebruik rico}

    push ds
    push si
    push $a000
    pop  ds

    mov Ztrans,256
{   mov Z,Zmax}
    mov cx,Zmax
    @loop2:
      add al,Prec_Xrico
      adc bl,Xrico
      add ah,Prec_Yrico
      adc bh,Yrico

      push bx
      push ax

      mov bl,es:[bx]     {VRAAG DIEPTE OP  0..255}
{  DOEP}
(*
      mov ax,z
      shr di,1
      shl ax,6
      add di,ax
      shl ax,2
      add di,ax
      mov ds:[di],bl  {DOPE}
      mov ax,z
      shl ax,6
      sub di,ax
      shl ax,2
      sub di,ax
      shl di,1*)
 {COLOR = HOOGTE}
{     mov al,bl}


      xor bh,bh

      add bx,bx   {BX=TRANS_TABEL[DIEPTE]+calloffset}
      add bx,Ztrans
{     mov bx,cs:[bx]+offset @trans_tabel     {Door 'strech Z and *5'-tabel halen}
      db $64,$8B,$1F {mov bx,fs:[bx]  {Door 'strech Z and *5'-tabel halen}

      mov si,prev_height

      cmp si,bx
      jbe @nevermind



      mov dh,$C3    { CS:[Prev_height+offset @mlcode]:=$C3 }
      mov cs:[si]+offset @mlcode,dh

{     mov dx,0}
      mov dx,bx
      add dx,calloffset
      mov cs:[offset @na_jmp-2],dx

      mov si,x
 {COLOR = Z}
      mov al,cl

      jmp @cache_clear
@cache_clear:

      call @mlcode   {db $E8;dw verschil;}
    @na_jmp:

      mov si,prev_height
      mov dh,$3E    { CS:[Prev_height+offset @mlcode]:=$3E }
      mov cs:[si]+offset @mlcode,dh
(*
      mov dh,$C3    { CS:[offset @mlcodelast]:=$C3 }
      mov cs:[offset @mlcodelast],dh
*)
      mov prev_height,bx


  @nevermind:
      pop ax
      pop bx

      add Ztrans,256
      dec cl
{     dec z}
    jnz @loop2

    mov dx,0
    mov si,x
    mov cx,prev_height
@cleanvert:
    mov ds:[si],dl
    add si,320
    sub cx,5
    jg  @cleanvert

    pop si
    pop ds

    add di,2
    inc x
    cmp x,320
  jne @loop1
  jmp @mlcodeend

@mlcode:
  db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0;
  db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0;
  db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0;
  db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0;
  db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0;
  db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0;
  db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0;
  db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0;
  db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0;
  db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0;
  db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0;
  db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0;
  db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0;
  db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0;
  db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0;
  db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0;
  db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0;
  db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0;
  db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0;
  db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0;

  db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0;
  db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0;
  db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0;
  db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0;
  db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0;
  db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0;
  db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0;
  db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0;
  db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0;
  db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0;
  db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0;
  db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0;
  db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0;
  db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0;
  db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0;
  db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0;
  db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0;
  db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0;
  db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0;
  db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0; db $3E,$88,$84;dw 0;
@mlcodelast:
  db $C3,$C3,$C3,$C3,$C3,$C3,$C3,$C3,$C3,$C3,$C3,$C3,$C3,$C3,$C3,$C3,$C3,$C3,$C3,$C3

{
  dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
@trans_tabel:
  dw   0,  5, 10, 15, 20, 25, 30, 35, 40, 45, 50, 55, 60, 65, 70, 75, 80, 85, 90, 95
  dw 100,105,110,115,120,125,130,135,140,145,150,155,160,165,170,175,180,185,190,195
  dw 200,205,210,215,220,225,230,235,240,245,250,255,260,265,270,275,280,285,290,295
  dw 300,305,310,315,320,325,330,335,340,345,350,355,360,365,370,375,380,385,390,395
  dw 400,405,410,415,420,425,430,435,440,445,450,455,460,465,470,475,480,485,490,495
  dw 500,505,510,515,520,525,530,535,540,545,550,555,560,565,570,575,580,585,590,595
  dw 600,605,610,615,620,625,630,635,640,645,650,655,660,665,670,675,680,685,690,695
  dw 700,705,710,715,720,725,730,735,740,745,750,755,760,765,770,775,780,785,790,795
  dw 800,805,810,815,820,825,830,835,840,845,850,855,860,865,870,875,880,885,890,895
  dw 900,905,910,915,920,925,930,935,940,945,950,955,960,965,970,975,980,985,990,995
  dw 1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000
  dw 1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000
  dw 1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000
  dw 1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000
  dw 1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000
}
@mlcodeend:
  end;
end;
procedure Animation;
begin
  Xcam:=128;
  Ycam:=128;
  angle:=512;
  writetxt(0,0,'Hoi');
  repeat
{    Retrace;}
    Setcol(0,0,0,0);
    Calc_Angle;
    Setcol(0,0,0,0);
    Draw_3d;
    Setcol(0,0,0,0);
{
    if key=',' then begin dec(anglespeed,8);key:=CHR(255);end;
    if key='.' then begin inc(anglespeed,8);key:=CHR(255);end;
    if key=CHR(0) then begin
      key:=readkey;
      if key=CHR(75) then dec(Xcamspeed,2);
      if key=CHR(77) then inc(Xcamspeed,2);
      if key=CHR(72) then dec(Ycamspeed,2);
      if key=CHR(80) then inc(Ycamspeed,2);
      key:=CHR(255);
    end;}
{   inc(Xcamspeed,random(7)-3);
    inc(Ycamspeed,random(7)-3);
    inc(anglespeed,random(17)-8);}
    Xcamspeed:=trunc(SIN(bigcntr/360*pi)*3);
    Ycamspeed:=trunc(SIN(bigcntr2/400*pi)*3);
    anglespeed:=trunc(SIN(bigcntr3/180*pi)*25);
    bigcntr :=(bigcntr +2) MOD 720;
    bigcntr2:=(bigcntr2+2) MOD 800;
    bigcntr3:=(bigcntr3+3) MOD 360;

{
    if Xcamspeed<-32 then Xcamspeed:=-32;
    if Xcamspeed> 32 then Xcamspeed:= 32;
    if Ycamspeed<-32 then Ycamspeed:=-32;
    if Ycamspeed> 32 then Ycamspeed:= 32;
    if anglespeed<-48 then anglespeed:=-48;
    if anglespeed> 48 then anglespeed:= 48;
    if Xcamspeed<0 then inc(Xcamspeed);
    if Xcamspeed>0 then dec(Xcamspeed);
    if Ycamspeed<0 then inc(Ycamspeed);
    if Ycamspeed>0 then dec(Ycamspeed);
    if anglespeed<0 then inc(anglespeed);
    if anglespeed>0 then dec(anglespeed);
}
    inc(Xcam,Xcamspeed);
    inc(Ycam,Ycamspeed);
    inc(angle,anglespeed);

    quit:=false;
    if keypressed then key:=readkey;
    if key=CHR(27) then quit:=true;
  until quit=true;
end;

begin
  GetMem(juliamem,65535);
  GetMem(transmem,64000);
  Getfont;
  SetGraphics;
  SetPal;

  if Julia_file=false then Calc_Julia;
  Load_Julia;

  SetPalGrey;

  for maal2:=1 to Zmax do begin
    for maal:=0 to 127 do begin
      myval:=((maal-80)*80) DIV maal2+100;
      myval:=myval*5;
      if myval<0    then myval:=0;
      if myval>1000 then myval:=1000;
      memw[SEG(transmem^):maal*2+maal2 shl 8]:=myval;
    end;
  end;
  Animation;
  ReSetGraphics;
  FreeMem(transmem,64000);
  FreeMem(juliamem,65535);
end.