{
> I would like to include a clock in my current project which will be
> updated once a minute.  Instead of constantly checking the computer's clock
> and waiting for it to change, I would like to use an interrupt.

This one has even a hot key handler.  If you want to update it once per
minute, bump a counter within the interrupt 1Ch handler till it reaches the
value 60*18.2.  Then refresh the screen.
}

Program Clock;

{ G+,R-,S-,M 1024, 0, 0 }
{$G+,R-,S-,M 16000, 1024, 1024 }

uses
  Dos,Crt;

Const
  x           = 0;                   { x location on screen }
  y           = 1;                    { y location on screen }
  Keyboard    = 9;                    { Hardware keyboard interrupt }
  TimerTick   = $1C;                  { Gets called 18.2 / second }
  VideoOffset = 160 * (y - 1) + 2 * x;{ Offset in display memory }
  yellow      = 14;
  blue        = 1;
  attribute   = lightgray * 16 + white;   { Clock colours }
  VideoBase   : Word = $B800;         { Segment of display memory }
  ActiveFlag  : ShortInt = -1;        { 0: on, -1: off }

Var
  OrgInt9,                             { Saved interrupt 9 vector }
  OrgInt1Ch : Pointer;              { Saved interrupt 1Ch vector }
  VideoMode : Byte absolute $0000:$0449;
  fseg,fofs:word;
  rijtje:array[0..7] of byte;
  rijnr:word;
  zoekwoord,zoekwoord2:string[10];
  zoekwoordlen:word;
  intercept_do_it:word;

  cntr:word;

  zoekwoord_aktief:word;
  Logpos:word;
  Log:array[0..255] of byte;
  Log_ASCII:array[0..255] of byte;
  filename: string;
  binfile : file of byte;
{ Display a string using Dos services (avoid WriteLn, save memory) }


procedure setpal(c,r,g,b:byte); assembler; asm
  mov dx,3c8h; mov al,[c]; out dx,al; inc dx; mov al,[r]
  out dx,al; mov al,[g]; out dx,al; mov al,[b]; out dx,al; end;
procedure retrace; assembler; asm
  mov dx,3dah; @vert1: in al,dx; test al,8; jz @vert1
  @vert2: in al,dx; test al,8; jnz @vert2; end;
procedure _25lines; assembler;
asm
  mov ax,83h {83h}
  int 10h
end;
procedure _50lines; assembler;
asm
  mov ax,1202h
  mov bl,30h
  int 10h
  mov ax,1112h
  mov bl,0
  int 10h
end;

Procedure DisplayString(s : String); Assembler;

ASM
  PUSH   DS
  XOR    CX, CX
  LDS    SI, s
  LODSB
  MOV    CL, AL
  JCXZ   @EmptyString
  CLD
 @NextChar:
  LODSB
  XCHG   AX, DX
  MOV    AH, 2
  INT    21h
  LOOP   @NextChar
 @EmptyString:
  POP    DS
end;
procedure writestring(str:string;x,y:word);
var
  cntr_loc:word;
begin
  for cntr_loc:=1 to length(str) do mem[Videobase:cntr_loc shl 1+(80*2*y)+x*2]:=ord(str[cntr_loc]);
end;

{ Returns True if a real time clock could be found }
Function HasRTClock : Boolean; Assembler;

ASM
  XOR    AL, AL
  MOV    AH, 2
  INT    1Ah
  JC     @NoRTClock
  INC    AX
 @NoRTCLock:
end;

{ Release Dos environment }
Procedure ReleaseEnvironment; Assembler;
ASM
  MOV    ES, [PrefixSeg]
  MOV    ES, ES:[002Ch]
  MOV    AH, 49h
  INT    21h
end;
{ Convert a packed BCD byte to ASCII character }
Procedure Digit; Assembler;
ASM
  PUSH   AX
  CALL   @HiNibble
  POP    AX
  CALL   @LoNibble
  RETN

 @HiNibble:
  SHR    AL, 4
  JMP    @MakeAscii
 @LoNibble:
  AND    AL, 0Fh
 @MakeAscii:
  OR     AL, '0'
  STOSW
end;
{ Convert a packed BCD byte to ASCII character }
{const
  hex:array[0..15] of char=('0','1','2','3','4','5','6','7','8',
                            '9','A','B','C','D','E','F');}
Procedure Digit_big; Assembler;
ASM
  jmp @skip
 @hex:db '0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'
 @skip:
{ xor bx,bx
  mov bl,dh
  and bl,$f0;
  shr bl,4
  mov al,cs:[offset @hex+bx]
  stosw
  mov bl,dh
  and bl,$0f;
  mov al,cs:[offset @hex+bx]
  stosw}
  mov bl,dl
  and bl,$f0;
  shr bl,4
  mov al,cs:[offset @hex+bx]
  stosw
  mov bl,dl
  and bl,$0f;
  mov al,cs:[offset @hex+bx]
  stosw
end;

procedure Interceptions;
var
  K:byte;
begin
  intercept_do_it:=0;
  k:=0;
  repeat
    setpal(0,k,0,0);
    retrace;
    k:=(k+1) AND 63;
  until k=80;
end;


{ INT 9 handler intercepting Alt-F11 }
Procedure ToggleClock; Interrupt; Assembler;
var
  key:byte;
Const
  F11      = $57;                  { 'F11' make code }
  BiosSeg  = $40;                  { Segment of BIOS data area }
  AltMask  = $08;                  { Bitmask of Alt key }
  KbdFlags = $17;                  { Byte showing keyboard status }

  break_key= $46; {was $46}

ASM
  STI
  IN     Al, 60h  {al}
  mov key,al


  pusha


  CMP    [ActiveFlag], 0
  JNE    @Exit2

{update rijtje}
  mov bx,rijnr
  mov al,key
  mov ds:[offset rijtje+bx],al
  inc bx      {volgende rijnr}
  and bx,7
  mov rijnr,bx

{print rijtje}
  mov cx,rijnr
  MOV ES, [VideoBase]
  MOV DI, VideoOffset
  add di,(80-2)*2{+(80)*2*16}
@loop:
  mov si, offset rijtje
  add si,cx
  mov al,ds:[si]
  MOV AH, attribute {!}

  mov dx,ax  {alles in dx meegeven}
  call digit_big

  add di,(80-2)*2 {volgende regel op scherm}
  inc cx     {volgende in rijtje}
  cmp cx,8
  jne @niet8
  mov cx,0
 @niet8:
  cmp cx,rijnr
  jne @loop
 @Exit2:


  popa


 { F11 pressed? }
  CMP    AL, F11
  JNE    @PassThru

 { Alt-key pressed? }
  PUSH   BiosSeg
  POP    ES
  MOV    AL, ES:[KbdFlags]
  AND    AL, AltMask
  CMP    AL, AltMask
  JNE    @PassThru

 { Flip status flag, force EOI and leave routine }
  mov intercept_do_it,$ffff;
  and    [ActiveFlag],0
  IN     AL, 61h
  MOV    AH, AL
  OR     AL, 80h
  OUT    61h, AL
  MOV    AL, AH
  OUT    61h, AL
  CLI
  MOV    AL, 20h
  OUT    20h, AL
  STI
  JMP    @Exit

 @PassThru:
  CLI
  PUSHF
  CALL   DWord Ptr [OrgInt9]
 @Exit:
end;  { ToggleClock }

procedure getfont; assembler; asm
  mov ax,1130h; mov bh,6; int 10h; mov fseg,es; mov fofs,bp; end;
procedure writetxt(x,y:word; txt:string);
var i,j,k:byte;
begin
  for i:=1 to length(txt) do for j:=0 to 15 do for k:=0 to 7 do
    if ((mem[fseg:fofs+ord(txt[i])*16+j] shl k) and 128) <> 0 then begin
      mem[$a000:(y+j)*320+((i-1)*8)+x+k]:=63;
    end;
end;

procedure naar_VGA;
begin
  asm
    Mov AX,93h; {13h}
    Int 10h  { Go_Grafix_Mode 320x200x256}
  end;
{ Directvideo:=false;}
end;

procedure plasmatic;
var
  cntr,cntr2:word;
  val:byte;
begin
  setpal(0,16,16,16);
  setpal(63,63,63,63);
  for cntr2:=0 to 80 do begin
    for cntr:=0 to 319 do begin
      val:=mem[$a000:cntr+cntr2 shl 6+cntr2 shl 8];
      if (val=0) OR (val>63) then mem[$a000:cntr+cntr2 shl 6+cntr2 shl 8]:=(cntr+cntr2) AND 15+128;
    end;
  end;
end;
{ INT 1Ch handler that displays a clock on the right hand side of the screen }
Procedure DisplayClock; Interrupt;
begin
ASM
  CMP    [ActiveFlag], 0
  JNE    @Exit
  CLD
  MOV    AH, 2
  INT    1Ah
  MOV    ES, [VideoBase]
  MOV    DI, VideoOffset
  add    di,69*2  {70 karakters naar rechts}
  MOV    AH, attribute {!}
  MOV    AL, CH
  CALL   Digit
  MOV    AL, ':'
  STOSW
  MOV    AL, CL
  CALL   Digit
  MOV    AL, ':'
  STOSW
  MOV    AL, DH
  CALL   Digit         {!}
  MOV    AL, ' '
  STOSW

  PUSHF
  CALL   DWord Ptr [OrgInt1Ch]
 @Exit:
end;
end;

Begin
  If VideoMode = 7 Then
    VideoBase := $B000;
  getfont;
  rijnr:=0;
  GetIntVec(TimerTick, OrgInt1Ch);
  SetIntVec(TimerTick, @DisplayClock);
  GetIntVec(Keyboard, OrgInt9);
  SetIntVec(Keyboard, @ToggleClock);
  SwapVectors;
  ReleaseEnvironment;
  DisplayString('CLOCK installed.  <Alt-F11> toggles on/off');
  Keep(0);
end.
