function SQRT_benadering(inp:longint):longint;
var
  point:word;
begin
  point:=0;
  repeat
    if inp>8192 then begin
      inp:=inp shr 2;
      inc(point);
    end;
  until inp<=8192;
  SQRT_benadering:=meml[wortelSEG:(inp) shl 2] shl point;
end;




{------  ROTATE WERKLIJN PROCEDURES    (BEGIN)}
var
  rwl_sin_a,rwl_cos_a,rwl_pyth_len:real;
  rwl_sin_b,rwl_cos_b:real;
  rwl_Xc ,rwl_Yc :longint;
  rwl_Xc_,rwl_Yc_:longint;
  rwl_cos_a_fix,rwl_sin_a_fix:longint;
  rwl_cos_b_fix,rwl_sin_b_fix:longint;
  Xc_fix ,Yc_fix :longint;
  Xc_fix_,Yc_fix_:longint;


procedure bereken_rotation_werklijn_alpha(vectx,vecty:longint); {SLOW}
begin
  if (vectx<>0) OR (vecty<>0) then begin
{   rwl_pyth_len:=(sqrt(sqr(vectx/65536)+sqr(vecty/65536)))*65536;}
    rwl_pyth_len:=sqrt_benadering(trunc(vectx*vectx+vecty*vecty)) shr 16;
    rwl_sin_a:=(-vectx)/rwl_pyth_len;
    rwl_cos_a:=(-vecty)/rwl_pyth_len;
  end else begin
    rwl_sin_a:=0;
    rwl_cos_a:=1;
  end;
  rwl_cos_a_fix:=trunc(rwl_cos_a*16777216);
  rwl_sin_a_fix:=trunc(rwl_sin_a*16777216);
end;
{procedure rotate_point_alpha(Xc,Yc:longint;VAR Xc_,Yc_:longint);{SLOW}
{begin
  rwl_Xc_:=trunc((Xc*rwl_cos_a)-(Yc*rwl_sin_a));
  rwl_Yc_:=trunc((Xc*rwl_sin_a)+(Yc*rwl_cos_a));
  Xc_:=rwl_Xc_;
  Yc_:=rwl_Yc_;
end;}
{procedure rotate_point_alpha_rev(Xc,Yc:longint;VAR Xc_,Yc_:longint);{SLOW}
{begin
  rwl_Xc_:=trunc((Xc*rwl_cos_a)+(Yc*rwl_sin_a));
  rwl_Yc_:=trunc(-(Xc*rwl_sin_a)+(Yc*rwl_cos_a));
  Xc_:=rwl_Xc_;
  Yc_:=rwl_Yc_;
end;}

procedure bereken_rotation_werklijn_beta(vectx,vecty:longint);{SLOW}
begin
  if (vectx<>0) OR (vecty<>0) then begin
{   rwl_pyth_len:=(sqrt(sqr(vectx/65536)+sqr(vecty/65536)))*65536;}
    rwl_pyth_len:=sqrt_benadering(trunc(vectx*vectx+vecty*vecty)) shr 16;
    rwl_sin_b:=(-vectx)/rwl_pyth_len;
    rwl_cos_b:=(-vecty)/rwl_pyth_len;
  end else begin
    rwl_sin_b:=0;
    rwl_cos_b:=1;
  end;
  rwl_cos_b_fix:=trunc(rwl_cos_b*16777216);
  rwl_sin_b_fix:=trunc(rwl_sin_b*16777216);
end;
{procedure rotate_point_beta(Xc,Yc:longint;VAR Xc_,Yc_:longint);{SLOW}
{begin
  rwl_Xc_:=trunc((Xc*rwl_cos_b)-(Yc*rwl_sin_b));
  rwl_Yc_:=trunc((Xc*rwl_sin_b)+(Yc*rwl_cos_b));
  Xc_:=rwl_Xc_;
  Yc_:=rwl_Yc_;
end;}
{-----------------  ROTATE WERKLIJN PROCEDURES    (EIND)}

procedure rotate_point_alpha(Xc,Yc:longint;VAR Xc_,Yc_:longint); {FAST!}
begin
  XC_fix:=Xc;
  YC_fix:=Yc;
  asm
    db $66;mov ax,ds:[offset rwl_cos_a_fix]
    db $66;mov bx,ds:[offset Xc_fix]
    {cdq}    db $66,$99
    {imul ebx}  db $66,$F7,$EB
    {push eax} db $66,$50
    {push edx} db $66,$52

    db $66;mov ax,ds:[offset rwl_sin_a_fix];
    {neg eax;}db $66,$f7,$D8
    db $66;mov bx,ds:[offset Yc_fix]
    {cdq}    db $66,$99
    {imul ebx}  db $66,$F7,$EB

    {pop ecx} db $66,$59
    {pop ebx} db $66,$5B
    {add eax,ebx} db $66,$03,$C3
    {adc edx,ecx} db $66,$13,$D1

    {shrd eax,edx,24} db $66,$0F,$AC,$D0,$18
    {shr edx,24}      db $66,$C1,$EA,$18
    db $66;mov ds:[offset Xc_fix_],ax
  end;
  asm
    db $66;mov ax,ds:[offset rwl_sin_a_fix]
    db $66;mov bx,ds:[offset Xc_fix]
    {cdq}    db $66,$99
    {imul ebx}  db $66,$F7,$EB
    {push eax} db $66,$50
    {push edx} db $66,$52

    db $66;mov ax,ds:[offset rwl_cos_a_fix];
    db $66;mov bx,ds:[offset Yc_fix]
    {cdq}    db $66,$99
    {imul ebx}  db $66,$F7,$EB

    {pop ecx} db $66,$59
    {pop ebx} db $66,$5B
    {add eax,ebx} db $66,$03,$C3
    {adc edx,ecx} db $66,$13,$D1

    {shrd eax,edx,24} db $66,$0F,$AC,$D0,$18
    {shr edx,24}      db $66,$C1,$EA,$18
    db $66;mov ds:[offset Yc_fix_],ax
  end;
  Xc_:=Xc_fix_;
  Yc_:=Yc_fix_;

{ rwl_Xc_:=trunc((Xc*rwl_cos_a)-(Yc*rwl_sin_a));
  rwl_Yc_:=trunc((Xc*rwl_sin_a)+(Yc*rwl_cos_a));}
{ Xc_:=rwl_Xc_;
  Yc_:=rwl_Yc_;}
end;
procedure rotate_point_alpha_rev(Xc,Yc:longint;VAR Xc_,Yc_:longint); {FAST!}
begin
  XC_fix:=Xc;
  YC_fix:=Yc;
  asm
    db $66;mov ax,ds:[offset rwl_cos_a_fix]
    db $66;mov bx,ds:[offset Xc_fix]
    {cdq}    db $66,$99
    {imul ebx}  db $66,$F7,$EB
    {push eax} db $66,$50
    {push edx} db $66,$52

    db $66;mov ax,ds:[offset rwl_sin_a_fix];
    db $66;mov bx,ds:[offset Yc_fix]
    {cdq}    db $66,$99
    {imul ebx}  db $66,$F7,$EB

    {pop ecx} db $66,$59
    {pop ebx} db $66,$5B
    {add eax,ebx} db $66,$03,$C3
    {adc edx,ecx} db $66,$13,$D1

    {shrd eax,edx,24} db $66,$0F,$AC,$D0,$18
    {shr edx,24}      db $66,$C1,$EA,$18
    db $66;mov ds:[offset Xc_fix_],ax
  end;
  asm
    db $66;mov ax,ds:[offset rwl_sin_a_fix]
    db $66;mov bx,ds:[offset Xc_fix]
    {neg eax;}db $66,$f7,$D8
    {cdq}    db $66,$99
    {imul ebx}  db $66,$F7,$EB
    {push eax} db $66,$50
    {push edx} db $66,$52

    db $66;mov ax,ds:[offset rwl_cos_a_fix];
    db $66;mov bx,ds:[offset Yc_fix]
    {cdq}    db $66,$99
    {imul ebx}  db $66,$F7,$EB

    {pop ecx} db $66,$59
    {pop ebx} db $66,$5B
    {add eax,ebx} db $66,$03,$C3
    {adc edx,ecx} db $66,$13,$D1

    {shrd eax,edx,24} db $66,$0F,$AC,$D0,$18
    {shr edx,24}      db $66,$C1,$EA,$18
    db $66;mov ds:[offset Yc_fix_],ax
  end;
  Xc_:=Xc_fix_;
  Yc_:=Yc_fix_;

{ rwl_Xc_:=trunc((Xc*rwl_cos_a)+(Yc*rwl_sin_a));
  rwl_Yc_:=trunc(-(Xc*rwl_sin_a)+(Yc*rwl_cos_a));
{ Xc_:=rwl_Xc_;
  Yc_:=rwl_Yc_;}
end;
procedure rotate_point_beta(Xc,Yc:longint;VAR Xc_,Yc_:longint); {FAST!}
begin
  XC_fix:=Xc;
  YC_fix:=Yc;
  asm
    db $66;mov ax,ds:[offset rwl_cos_b_fix]
    db $66;mov bx,ds:[offset Xc_fix]
    {cdq}    db $66,$99
    {imul ebx}  db $66,$F7,$EB
    {push eax} db $66,$50
    {push edx} db $66,$52

    db $66;mov ax,ds:[offset rwl_sin_b_fix];
    {neg eax;}db $66,$f7,$D8
    db $66;mov bx,ds:[offset Yc_fix]
    {cdq}    db $66,$99
    {imul ebx}  db $66,$F7,$EB

    {pop ecx} db $66,$59
    {pop ebx} db $66,$5B
    {add eax,ebx} db $66,$03,$C3
    {adc edx,ecx} db $66,$13,$D1

    {shrd eax,edx,24} db $66,$0F,$AC,$D0,$18
    {shr edx,24}      db $66,$C1,$EA,$18
    db $66;mov ds:[offset Xc_fix_],ax
  end;
  asm
    db $66;mov ax,ds:[offset rwl_sin_b_fix]
    db $66;mov bx,ds:[offset Xc_fix]
    {cdq}    db $66,$99
    {imul ebx}  db $66,$F7,$EB
    {push eax} db $66,$50
    {push edx} db $66,$52

    db $66;mov ax,ds:[offset rwl_cos_b_fix];
    db $66;mov bx,ds:[offset Yc_fix]
    {cdq}    db $66,$99
    {imul ebx}  db $66,$F7,$EB

    {pop ecx} db $66,$59
    {pop ebx} db $66,$5B
    {add eax,ebx} db $66,$03,$C3
    {adc edx,ecx} db $66,$13,$D1

    {shrd eax,edx,24} db $66,$0F,$AC,$D0,$18
    {shr edx,24}      db $66,$C1,$EA,$18
    db $66;mov ds:[offset Yc_fix_],ax
  end;
  Xc_:=Xc_fix_;
  Yc_:=Yc_fix_;

{ rwl_Xc_:=trunc((Xc*rwl_cos_b)-(Yc*rwl_sin_b));
  rwl_Yc_:=trunc((Xc*rwl_sin_b)+(Yc*rwl_cos_b));}
{ Xc_:=rwl_Xc_;
  Yc_:=rwl_Yc_;}
end;
