procedure setpal(c,r,g,b:byte); assembler; asm
  mov dx,3c8h; mov al,[c]; out dx,al; inc dx; mov al,[r]
  out dx,al; mov al,[g]; out dx,al; mov al,[b]; out dx,al; end;

procedure SetGraphics(Mode : byte); assembler;
asm mov AH,0;mov AL,Mode;int 10h;end;

procedure retrace; assembler; asm
  mov dx,3dah; @vert1: in al,dx; test al,8; jz @vert1
  @vert2: in al,dx; test al,8; jnz @vert2; end;
{A 640x480x256 vesa test by Jack}
{Video Modes:
101h    640x480x256
103h    800x600x256
105h    1024x768x256
110h    640x480x32k (?)
}
var
  X, Y : Word;
  Current_Bank : Word;

procedure setmode (mode : word); assembler;
asm
  mov ax,4F02h
  mov bx,mode
  int 10h
end;

procedure setbank(bank:word);assembler;
asm
  mov ax, 4f05h
  mov bx, 0h
  mov dx, bank
  mov Current_Bank, dx
  int 10h
end;

procedure setpix(x,y,col:word);assembler;
var  decalage:word;
      asm
 mov bx,x
 mov ax,y {removed all range checking on x,y for speed}
 mov cx, 1280
 mul cx {640 bytes wide in most cases}
 add bx,ax
{ adc dx,0}
 mov ax, dx { what a $#%%# stupid microprocessor}
 adc ax, 0

  {mov provi,al}   { bank  }
  mov decalage,bx
  cmp ax,Current_Bank
  jz @nonew
  mov ah,0
  push cs
  push ax
  call setbank   { here ax = bank }
  @nonew:

  mov bx,col
  mov ax,sega000
  mov es,ax
  mov di,decalage
  mov [es:di],bl
end;
procedure copy_screen;
var
  coldark:byte;
begin
  coldark:=0;
  asm
    push ds
    push si
    mov ax,VirScreenBase;
    mov es,ax
    mov ax,$a000
    mov ds,ax
    mov si,0
    mov cx,4000
    db $66;xor ax,ax
    mov bl,coldark
    mov bh,bl
    mov ax,bx
    db $66;shl ax,16
    mov ax,bx
  @loop:
    db $66;mov bx,es:[si]
    db $66;mov ds:[si],bx
    add si,4
    db $66;mov bx,es:[si]
    db $66;mov ds:[si],bx
    add si,4
    db $66;mov bx,es:[si]
    db $66;mov ds:[si],bx
    add si,4
    db $66;mov bx,es:[si]
    db $66;mov ds:[si],bx
    add si,4
    dec cx
    jnz @loop
    pop si
    pop ds
  end;
end;
procedure copy_screen_echo;
var
  coldark:word;
begin
  coldark:=teller AND 1;
  asm
    push ds
    push si
    mov ax,VirScreenBase;
    mov es,ax
    mov ax,$a000
    mov ds,ax
    mov si,0
    mov ch,200
  @loop2:
    mov ax,coldark
    inc ax
    and ax,1
    mov coldark,ax
    mov cl,40
    db $66;xor ax,ax
    add si,coldark
    mov ax,bx
    db $66;shl ax,16
    mov ax,bx
  @loop:
    mov bl,es:[si]
    mov ds:[si],bl
    add si,2
    mov bl,es:[si]
    mov ds:[si],bl
    add si,2
    mov bl,es:[si]
    mov ds:[si],bl
    add si,2
    mov bl,es:[si]
    mov ds:[si],bl
    add si,2
    dec cl
    jnz @loop
    sub si,coldark
    dec ch
    jnz @loop2
    pop si
    pop ds
  end;
end;
procedure lichter;
var
  r,g,b,r2,g2,b2:integer;
  dichtstbij,dichtbij:longint;
  colfound:byte;
  loc_cntr:word;
  startcol,eindcol:byte;
begin
  if brightness>256 then brightness:=256;
  loc_cntr:=lichter_input;
  r:=pal[loc_cntr*3]  +brightness;
  g:=pal[loc_cntr*3+1]+brightness;
  b:=pal[loc_cntr*3+2]+brightness;
  if r>63 then r:=63;
  if g>63 then g:=63;
  if b>63 then b:=63;
  if r<0  then r:=0 ;
  if g<0  then g:=0 ;
  if b<0  then b:=0 ;
  dichtstbij:=262144;
  colfound:=0;

  startcol:=0;eindcol:=255;
  if (lichter_input>= 16) AND (lichter_input<= 31) then begin startcol:= 16;eindcol:= 31; end;
  if (lichter_input>= 32) AND (lichter_input<= 55) then begin startcol:= 32;eindcol:= 55; end;
  if (lichter_input>= 56) AND (lichter_input<= 63) then begin startcol:= 56;eindcol:= 63; end;
  if (lichter_input>= 64) AND (lichter_input<= 79) then begin startcol:= 64;eindcol:= 79; end;
  if (lichter_input>= 80) AND (lichter_input<=111) then begin startcol:= 80;eindcol:=111; end;
  if (lichter_input>=112) AND (lichter_input<=159) then begin startcol:=112;eindcol:=159; end;
  if (lichter_input>=160) AND (lichter_input<=175) then begin startcol:=160;eindcol:=175; end;
  if (lichter_input>=176) AND (lichter_input<=191) then begin startcol:=176;eindcol:=191; end;
  if (lichter_input>=192) AND (lichter_input<=231) then begin startcol:=192;eindcol:=231; end;
  if (lichter_input>=240) AND (lichter_input<=255) then begin startcol:=240;eindcol:=255; end;


  for loc_cntr:=startcol to eindcol do begin
    r2:=pal[loc_cntr*3];
    g2:=pal[loc_cntr*3+1];
    b2:=pal[loc_cntr*3+2];
    dichtbij:=ABS(r-r2)+ABS(g-g2)+ABS(b-b2);
    if dichtbij<dichtstbij then begin
      colfound:=loc_cntr;
      dichtstbij:=dichtbij;
    end;
  end;
  lichter_output:=colfound;
end;
procedure lichter2;
var
  r,g,b,r2,g2,b2:integer;
  dichtstbij,dichtbij:longint;
  colfound:byte;
  loc_cntr:word;
  startcol,eindcol:byte;
begin
  if brightness>64 then brightness:=64;
  loc_cntr:=lichter_input;
  r:=(pal[loc_cntr*3]  *(64-brightness)+63*brightness) DIV 64;
  g:=(pal[loc_cntr*3+1]*(64-brightness)+63*brightness) DIV 64;
  b:=(pal[loc_cntr*3+2]*(64-brightness)+63*brightness) DIV 64;
  if r>63 then r:=63;
  if g>63 then g:=63;
  if b>63 then b:=63;
  if r<0  then r:=0 ;
  if g<0  then g:=0 ;
  if b<0  then b:=0 ;
  dichtstbij:=262144;
  colfound:=0;

  startcol:=0;eindcol:=255;
{ if lichter_input=0 then begin startcol:=0;eindcol:=0;end;}
{
  if (lichter_input>= 16) AND (lichter_input<= 31) then begin startcol:= 16;eindcol:= 31; end;
  if (lichter_input>= 32) AND (lichter_input<= 55) then begin startcol:= 32;eindcol:= 55; end;
  if (lichter_input>= 56) AND (lichter_input<= 63) then begin startcol:= 56;eindcol:= 63; end;
  if (lichter_input>= 64) AND (lichter_input<= 79) then begin startcol:= 64;eindcol:= 79; end;
  if (lichter_input>= 80) AND (lichter_input<=111) then begin startcol:= 80;eindcol:=111; end;
  if (lichter_input>=112) AND (lichter_input<=159) then begin startcol:=112;eindcol:=159; end;
  if (lichter_input>=160) AND (lichter_input<=175) then begin startcol:=160;eindcol:=175; end;
  if (lichter_input>=176) AND (lichter_input<=191) then begin startcol:=176;eindcol:=191; end;
  if (lichter_input>=192) AND (lichter_input<=231) then begin startcol:=192;eindcol:=231; end;
  if (lichter_input>=240) AND (lichter_input<=255) then begin startcol:=240;eindcol:=255; end;
}

  for loc_cntr:=startcol to eindcol do begin
    r2:=pal[loc_cntr*3];
    g2:=pal[loc_cntr*3+1];
    b2:=pal[loc_cntr*3+2];
    dichtbij:=ABS(r-r2)+ABS(g-g2)+ABS(b-b2);
    if dichtbij<dichtstbij then begin
      colfound:=loc_cntr;
      dichtstbij:=dichtbij;
    end;
  end;
  lichter_output:=colfound;
end;
(*procedure put_sprite;
var
  offs:word;
  val:byte;
  add_height:word;
begin
  add_height:=random(V_speed) DIV 25000*320;
  for cntr:=0 to 63 do begin
    offs:=cntr*320;
    for cntr2:=0 to 63 do begin
      val:=mem[SEG(Blokjesmem^):320*16+256+offs];{320*16}
      if val<>0 then begin
        mem[VirScreenBase:35328+add_height+offs]:=val; {320*140}
      end;
      inc(offs);
    end;
  end;
end;*)
procedure put_sprite;
var
  cntr_loc,cntr2_loc:word;
  val_loc:byte;
  letter_ascii:byte;
  source_offset,dest_offset:word;
  let_nr:word;
  seg_from,seg_to:word;
  letter_width,letter_height:word;
begin
  seg_from:=SEG(Blokjesmem^);
  seg_to:=VirscreenBase;
  source_offset:=320*16+256;
  dest_offset:=random(V_speed) DIV 25000*320+35328;
  letter_width:=64;
  letter_height:=64;
      asm
        push es
        mov ax,seg_from
       {mov fs,ax} db $8E,$E0
        mov ax,seg_to
        mov es,ax
        mov si,source_offset
        mov di,dest_offset

        mov cx,letter_height
      @loop1:
        mov dx,letter_width
        shr dx,1
      @loop2:
       {mov ax,fs:[si]} db $64,$8B,$04
        cmp al,0
        je @skip_pix0
        mov es:[di],al
       @skip_pix0:
        cmp ah,0
        je @skip_pix1
        mov es:[di]+1,ah
       @skip_pix1:
        add si,2
        add di,2
        dec dx
        jnz @loop2
        sub si,letter_width
        sub di,letter_width
        add si,320
        add di,320
        dec cx
        jnz @loop1

        pop es
      end;
end;
procedure calc_sourcemem;
begin
  {SOURCEGAPMEM}
  col:=102;
  for cntr:=0 to 15 do begin
    for cntr2:=0 to 15 do begin
      for cntr3:=0 to 15 do begin
        for cntr4:=0 to 15 do begin
          mem[SEG(Sourcegapmem^):cntr*16+cntr2*16*256+cntr3+cntr4*256]:=col+random(3);
        end;
      end;
    end;
  end;
  {SOURCEMEM}
  for cntr:=0 to 15 do begin
    for cntr2:=0 to 15 do begin
      bloknr:=veld[cntr+cntr2*32];
      blokx:=bloknr MOD 20;
      bloky:=bloknr DIV 20;
      for cntr3:=0 to 15 do begin
        for cntr4:=0 to 15 do begin
          mem[SEG(Sourcemem^):cntr*16+cntr2*16*256+cntr3+cntr4*256]:=
            mem[SEG(blokjesmem^):cntr3+cntr4*320+blokx*16+bloky*16*320];
        end;
      end;
      bloknr:=veld[cntr+cntr2*32+16];
      blokx:=bloknr MOD 20;
      bloky:=bloknr DIV 20;
      for cntr3:=0 to 15 do begin
        for cntr4:=0 to 15 do begin
          mem[SEG(Sourcemem2^):cntr*16+cntr2*16*256+cntr3+cntr4*256]:=
            mem[SEG(blokjesmem^):cntr3+cntr4*320+blokx*16+bloky*16*320];
        end;
      end;
      bloknr:=veld[cntr+cntr2*32+16*32];
      blokx:=bloknr MOD 20;
      bloky:=bloknr DIV 20;
      for cntr3:=0 to 15 do begin
        for cntr4:=0 to 15 do begin
          mem[SEG(Sourcemem3^):cntr*16+cntr2*16*256+cntr3+cntr4*256]:=
            mem[SEG(blokjesmem^):cntr3+cntr4*320+blokx*16+bloky*16*320];
        end;
      end;
      bloknr:=veld[cntr+cntr2*32+16+16*32];
      blokx:=bloknr MOD 20;
      bloky:=bloknr DIV 20;
      for cntr3:=0 to 15 do begin
        for cntr4:=0 to 15 do begin
          mem[SEG(Sourcemem4^):cntr*16+cntr2*16*256+cntr3+cntr4*256]:=
            mem[SEG(blokjesmem^):cntr3+cntr4*320+blokx*16+bloky*16*320];
        end;
      end;
    end;
  end;
end;
procedure calc_sourcemem2;
begin
  {SOURCEGAPMEM}
  col:=102+5;
  for cntr:=0 to 15 do begin
    for cntr2:=0 to 15 do begin
      for cntr3:=0 to 15 do begin
        for cntr4:=0 to 15 do begin
          mem[SEG(Sourcegapmem^):cntr*16+cntr2*16*256+cntr3+cntr4*256]:=col+random(3);
        end;
      end;
    end;
  end;
  {SOURCEMEM}
  for cntr:=0 to 15 do begin
    for cntr2:=0 to 15 do begin
      mem[$a000:cntr2+cntr shl 4]:=10;
      mem[$a000:cntr2+cntr shl 4+320]:=10;
      mem[$a000:cntr2+cntr shl 4+640]:=10;
      mem[$a000:cntr2+cntr shl 4+960]:=10;
      bloknr:=veld[cntr+cntr2*32];
      blokx:=bloknr MOD 20;
      bloky:=bloknr DIV 20;
      for cntr3:=0 to 15 do begin
        for cntr4:=0 to 15 do begin
          lichter_input:=mem[SEG(blokjesmem^):cntr3+cntr4*320+blokx*16+bloky*16*320];
          brightness:=trunc(sin((cntr3+cntr *16)/512*pi)*16
                           +sin((cntr4+cntr2*16)/512*pi)*16)-32;
          if brightness<-64 then brightness:=-64;
          if brightness>63 then brightness:=63;
          inc(brightness,64);
          lichter_output:=mem[SEG(virscreen^):lichter_input+brightness shl 8];
          mem[SEG(Sourcemem^):cntr*16+cntr2*16*256+cntr3+cntr4*256]:=lichter_output;
{         mem[          $a000:cntr*16+cntr2*16*320+cntr3+cntr4*320]:=lichter_output;}
{         mem[SEG(Sourcemem^):cntr*16+cntr2*16*256+cntr3+cntr4*256]:=
            mem[SEG(blokjesmem^):cntr3+cntr4*320+blokx*16+bloky*16*320];}
        end;
      end;
      bloknr:=veld[cntr+cntr2*32+16];
      blokx:=bloknr MOD 20;
      bloky:=bloknr DIV 20;
      for cntr3:=0 to 15 do begin
        for cntr4:=0 to 15 do begin
          lichter_input:=mem[SEG(blokjesmem^):cntr3+cntr4*320+blokx*16+bloky*16*320];
          brightness:=trunc(sin((cntr3+cntr *16+16*16)/512*pi)*16
                           +sin((cntr4+cntr2*16)/512*pi)*16)-32;
          if brightness<-64 then brightness:=-64;
          if brightness>63 then brightness:=63;
          inc(brightness,64);
          lichter_output:=mem[SEG(virscreen^):lichter_input+brightness shl 8];
          mem[SEG(Sourcemem2^):cntr*16+cntr2*16*256+cntr3+cntr4*256]:=lichter_output;
{         mem[SEG(Sourcemem2^):cntr*16+cntr2*16*256+cntr3+cntr4*256]:=
            mem[SEG(blokjesmem^):cntr3+cntr4*320+blokx*16+bloky*16*320];}
        end;
      end;
      bloknr:=veld[cntr+cntr2*32+16*32];
      blokx:=bloknr MOD 20;
      bloky:=bloknr DIV 20;
      for cntr3:=0 to 15 do begin
        for cntr4:=0 to 15 do begin
          lichter_input:=mem[SEG(blokjesmem^):cntr3+cntr4*320+blokx*16+bloky*16*320];
          brightness:=trunc(sin((cntr3+cntr *16)/512*pi)*16
                           +sin((cntr4+cntr2*16+16*16)/512*pi)*16)-32;
          if brightness<-64 then brightness:=-64;
          if brightness>63 then brightness:=63;
          inc(brightness,64);
          lichter_output:=mem[SEG(virscreen^):lichter_input+brightness shl 8];
          mem[SEG(Sourcemem3^):cntr*16+cntr2*16*256+cntr3+cntr4*256]:=lichter_output;
{         mem[SEG(Sourcemem3^):cntr*16+cntr2*16*256+cntr3+cntr4*256]:=
            mem[SEG(blokjesmem^):cntr3+cntr4*320+blokx*16+bloky*16*320];}
        end;
      end;
      bloknr:=veld[cntr+cntr2*32+16+16*32];
      blokx:=bloknr MOD 20;
      bloky:=bloknr DIV 20;
      for cntr3:=0 to 15 do begin
        for cntr4:=0 to 15 do begin
          lichter_input:=mem[SEG(blokjesmem^):cntr3+cntr4*320+blokx*16+bloky*16*320];
          brightness:=trunc(sin((cntr3+cntr *16+16*16)/512*pi)*16
                           +sin((cntr4+cntr2*16+16*16)/512*pi)*16)-32;
          if brightness<-64 then brightness:=-64;
          if brightness>63 then brightness:=63;
          inc(brightness,64);
          lichter_output:=mem[SEG(virscreen^):lichter_input+brightness shl 8];
          mem[SEG(Sourcemem4^):cntr*16+cntr2*16*256+cntr3+cntr4*256]:=lichter_output;
{         mem[SEG(Sourcemem4^):cntr*16+cntr2*16*256+cntr3+cntr4*256]:=
            mem[SEG(blokjesmem^):cntr3+cntr4*320+blokx*16+bloky*16*320];}
        end;
      end;
    end;
  end;
end;
procedure player_control;
begin
    Vx_maal_vloer_hoogte:=4000*65536;  {2400}

    Vx_maal_vloer_hoogte1:=(trunc( sin(anglecam/1024*pi)*2000)*65536);  {2000}
    Vx_maal_vloer_hoogte2:=(trunc( cos(anglecam/1024*pi)*2000)*65536);  {2000}
    Vx_maal_vloer_hoogte3:=(trunc( cos(anglecam/1024*pi)*2000)*65536);  {2000}
    Vx_maal_vloer_hoogte4:=(trunc(-sin(anglecam/1024*pi)*2000)*65536);  {2000}
    Vx_maal_sprite_hoogte1:=(trunc( sin((-anglecam)/1024*pi)*4096));
    Vx_maal_sprite_hoogte2:=(trunc( cos((-anglecam)/1024*pi)*4096)); {WAS 65536}
    Vx_maal_sprite_hoogte3:=(trunc( cos((-anglecam)/1024*pi)*4096));
    Vx_maal_sprite_hoogte4:=(trunc(-sin((-anglecam)/1024*pi)*4096));



    prev_xplayer1:=xplayer1;
    prev_yplayer1:=yplayer1;

    inc(Vx_speed,Ax_speed);
    inc(Vy_speed,Ay_speed);

    Prev_v_speed:=V_speed;
    V_speed:=0;
    vx_speed_direction:=0;
    vy_speed_direction:=0;
    ax_speed_direction:=0;
    ay_speed_direction:=0;
    if (Vx_speed<>0) OR (Vy_speed<>0) then begin
      V_speed:=trunc(SQRT(SQR(Vx_speed/65536)+SQR(Vy_speed/65536))*65536);
      V_speed_ori:=V_speed;
      if player1_achteruit=false then
      if V_speed>40000 then V_speed:=40000; {50000=leuk voor RUMBLE,20000=leuk voor RACING}
      if player1_achteruit=true then
      if V_speed>20000 then V_speed:=20000; {50000=leuk voor RUMBLE,20000=leuk voor RACING}
      V_speed_new:=V_speed-2000;  {YS:-1000,STEEN:-2000}

      if V_speed<=2000 then begin
        V_speed:=0;
        V_speed_new:=0;
        vx_speed:=0;
        vy_speed:=0;
      end else begin
        Vx_speed_direction:=trunc(Vx_speed/V_speed_ori*32768);
        Vy_speed_direction:=trunc(Vy_speed/V_speed_ori*32768);
        Vx_speed:=trunc(Vx_speed/V_speed*V_speed_new);
        Vy_speed:=trunc(Vy_speed/V_speed*V_speed_new);
      end;
    end;
    if (Ax_speed<>0) OR (Ay_speed<>0) then begin
      A_speed:=trunc(SQRT(SQR(Ax_speed/65536)+SQR(Ay_speed/65536))*65536);
      if A_speed>=1000 then begin
        ax_speed_direction:=trunc(Ax_speed/A_speed*32768);
        ay_speed_direction:=trunc(Ay_speed/A_speed*32768);
      end;
    end;

    inc(xplayer1,Vx_speed);
    xchkpoint1:=xplayer1+playerfieldsize;
    ychkpoint1:=yplayer1+playerfieldsize;
    if veld[ (((xchkpoint1 shr 16)-256) shr 4)
            +(((ychkpoint1 shr 16)-256) shr 4)*32
                                                ]=1 then begin
      if prev_xplayer1<xplayer1 then begin
        xplayer1:=prev_xplayer1 AND $0fff00000+$0fffff;
        SMPoff:=80;
        Vx_speed:=-Vx_speed DIV 2;  {was -Vx_speed}
        inc(damage_long,ABS(Vx_speed));
      end;
      if prev_xplayer1>xplayer1 then begin
        xplayer1:=prev_xplayer1 AND $0fff00000;
        SMPoff:=80;
        Vx_speed:=-Vx_speed DIV 2;  {was -Vx_speed}
        inc(damage_long,ABS(Vx_speed));
      end;
    end;

    inc(yplayer1,Vy_speed);
    xchkpoint1:=xplayer1+playerfieldsize;
    ychkpoint1:=yplayer1+playerfieldsize;
    if veld[ (((xchkpoint1 shr 16)-256) shr 4)
            +(((ychkpoint1 shr 16)-256) shr 4)*32
                                                ]=1 then begin
      if prev_yplayer1<yplayer1 then begin
        yplayer1:=prev_yplayer1 AND $0fff00000+$0fffff;
        SMPoff:=80;
        Vy_speed:=-Vy_speed DIV 2;  {was -Vy_speed}
        inc(damage_long,ABS(Vy_speed));
      end;
      if prev_yplayer1>yplayer1 then begin
        yplayer1:=prev_yplayer1 AND $0fff00000;
        SMPoff:=80;
        Vy_speed:=-Vy_speed DIV 2;  {was -Vy_speed}
        inc(damage_long,ABS(Vy_speed));
      end;
    end;

    xcam:=xplayer1-Vx_maal_vloer_hoogte1 DIV 120; {DIV 120}
    ycam:=yplayer1-Vx_maal_vloer_hoogte2 DIV 120;
end;
procedure drawstretch_modem0;
begin
        asm
          push bp
          push si
          push es

          mov ax,reg_di        {eerste_teller nodig als   di AND 1=1  }
          and ax,1
          mov eerste_teller,ax
          mov ax,cntr2         {cntr2=cntr2-eerste_teller}
          sub ax,eerste_teller
          mov cntr2,ax
          mov ax,cntr2         {cntr2 shr 2 -> grote loop}
          shr ax,2
          mov drawstretch_teller,ax
          mov ax,cntr2         {kantje van grote loop afhalen}
          and ax,3
          mov laatste_teller,ax

          mov ax,reg_es
          mov es,ax
          mov ax,reg_ds            {NEW!}
         {mov fs,ax}  db $8E,$E0   {NEW!}
          mov ax,reg_ax
          mov bl,reg_bl
          mov bh,reg_bh
          mov dx,reg_dx
          mov si,reg_si
          mov di,reg_di
          mov bp,reg_bp

          cmp eerste_teller,0
          je @skiploop2
         {mov cl,fs:[bx]}  db $64,$8A,$0F
          add dx,ax;adc bl,0;add si,bp;adc bh,0
          mov es:[di],cl;inc di;
        @skiploop2:

          cmp drawstretch_teller,0
          je @skiploop0
        @loop0:
         {mov cl,fs:[bx]}  db $64,$8A,$0F
          add dx,ax;adc bl,0;add si,bp;adc bh,0
         {mov ch,fs:[bx]}  db $64,$8A,$2F
          add dx,ax;adc bl,0;add si,bp;adc bh,0
          mov es:[di],cx;add di,2;
         {mov cl,fs:[bx]}  db $64,$8A,$0F
          add dx,ax;adc bl,0;add si,bp;adc bh,0
         {mov ch,fs:[bx]}  db $64,$8A,$2F
          add dx,ax;adc bl,0;add si,bp;adc bh,0
          mov es:[di],cx;add di,2;
          dec drawstretch_teller;jnz @loop0
        @skiploop0:

          cmp laatste_teller,0
          je @skiploop1
        @loop1:
         {mov cl,fs:[bx]}  db $64,$8A,$0F
          add dx,ax;adc bl,0;add si,bp;adc bh,0
          mov es:[di],cl;inc di;
          dec laatste_teller;jnz @loop1
        @skiploop1:

          mov reg_si,si
          mov reg_bl,bl
          mov reg_bh,bh
          mov reg_di,di
          mov reg_dx,dx
          mov reg_ax,ax

          pop es
          pop si
          pop bp
        end;
end;
procedure drawstretch_modem1;
begin
        asm
          push bp
          push si
          push es

          mov ax,reg_di        {eerste_teller nodig als   di AND 1=1  }
          and ax,1
          mov eerste_teller,ax
          mov ax,cntr2         {cntr2=cntr2-eerste_teller}
          sub ax,eerste_teller
          mov cntr2,ax
          mov ax,cntr2         {cntr2 shr 2 -> grote loop}
          shr ax,2
          mov drawstretch_teller,ax
          mov ax,cntr2         {kantje van grote loop afhalen}
          and ax,3
          mov laatste_teller,ax

          mov ax,reg_es
          mov es,ax
          mov ax,reg_ds            {NEW!}
         {mov fs,ax}  db $8E,$E0   {NEW!}
          mov ax,reg_ax
          mov bl,reg_bl
          mov bh,reg_bh
          mov dx,reg_dx
          mov si,reg_si
          mov di,reg_di
          mov bp,reg_bp

          cmp eerste_teller,0
          je @skiploop2
         {mov cl,fs:[bx]}  db $64,$8A,$0F
          add dx,ax;adc bl,0;add si,bp;sbb bh,0
          mov es:[di],cl;inc di;
        @skiploop2:

          cmp drawstretch_teller,0
          je @skiploop0
        @loop0:
         {mov cl,fs:[bx]}  db $64,$8A,$0F
          add dx,ax;adc bl,0;add si,bp;sbb bh,0
         {mov ch,fs:[bx]}  db $64,$8A,$2F
          add dx,ax;adc bl,0;add si,bp;sbb bh,0
          mov es:[di],cx;add di,2;
         {mov cl,fs:[bx]}  db $64,$8A,$0F
          add dx,ax;adc bl,0;add si,bp;sbb bh,0
         {mov ch,fs:[bx]}  db $64,$8A,$2F
          add dx,ax;adc bl,0;add si,bp;sbb bh,0
          mov es:[di],cx;add di,2;
          dec drawstretch_teller;jnz @loop0
        @skiploop0:

          cmp laatste_teller,0
          je @skiploop1
        @loop1:
         {mov cl,fs:[bx]}  db $64,$8A,$0F
          add dx,ax;adc bl,0;add si,bp;sbb bh,0
          mov es:[di],cl;inc di;
          dec laatste_teller;jnz @loop1
        @skiploop1:

          mov reg_si,si
          mov reg_bl,bl
          mov reg_bh,bh
          mov reg_di,di
          mov reg_dx,dx
          mov reg_ax,ax

          pop es
          pop si
          pop bp
        end;
end;
procedure drawstretch_modem2;
begin
        asm
          push bp
          push si
          push es

          mov ax,reg_di        {eerste_teller nodig als   di AND 1=1  }
          and ax,1
          mov eerste_teller,ax
          mov ax,cntr2         {cntr2=cntr2-eerste_teller}
          sub ax,eerste_teller
          mov cntr2,ax
          mov ax,cntr2         {cntr2 shr 2 -> grote loop}
          shr ax,2
          mov drawstretch_teller,ax
          mov ax,cntr2         {kantje van grote loop afhalen}
          and ax,3
          mov laatste_teller,ax

          mov ax,reg_es
          mov es,ax
          mov ax,reg_ds            {NEW!}
         {mov fs,ax}  db $8E,$E0   {NEW!}
          mov ax,reg_ax
          mov bl,reg_bl
          mov bh,reg_bh
          mov dx,reg_dx
          mov si,reg_si
          mov di,reg_di
          mov bp,reg_bp

          cmp eerste_teller,0
          je @skiploop2
         {mov cl,fs:[bx]}  db $64,$8A,$0F
          add dx,ax;sbb bl,0;add si,bp;adc bh,0
          mov es:[di],cl;inc di;
        @skiploop2:

          cmp drawstretch_teller,0
          je @skiploop0
        @loop0:
         {mov cl,fs:[bx]}  db $64,$8A,$0F
          add dx,ax;sbb bl,0;add si,bp;adc bh,0
         {mov ch,fs:[bx]}  db $64,$8A,$2F
          add dx,ax;sbb bl,0;add si,bp;adc bh,0
          mov es:[di],cx;add di,2;
         {mov cl,fs:[bx]}  db $64,$8A,$0F
          add dx,ax;sbb bl,0;add si,bp;adc bh,0
         {mov ch,fs:[bx]}  db $64,$8A,$2F
          add dx,ax;sbb bl,0;add si,bp;adc bh,0
          mov es:[di],cx;add di,2;
          dec drawstretch_teller;jnz @loop0
        @skiploop0:

          cmp laatste_teller,0
          je @skiploop1
        @loop1:
         {mov cl,fs:[bx]}  db $64,$8A,$0F
          add dx,ax;sbb bl,0;add si,bp;adc bh,0
          mov es:[di],cl;inc di;
          dec laatste_teller;jnz @loop1
        @skiploop1:

          mov reg_si,si
          mov reg_bl,bl
          mov reg_bh,bh
          mov reg_di,di
          mov reg_dx,dx
          mov reg_ax,ax

          pop es
          pop si
          pop bp
        end;
end;
procedure drawstretch_modem3;
begin
        asm
          push bp
          push si
          push es

          mov ax,reg_di        {eerste_teller nodig als   di AND 1=1  }
          and ax,1
          mov eerste_teller,ax
          mov ax,cntr2         {cntr2=cntr2-eerste_teller}
          sub ax,eerste_teller
          mov cntr2,ax
          mov ax,cntr2         {cntr2 shr 2 -> grote loop}
          shr ax,2
          mov drawstretch_teller,ax
          mov ax,cntr2         {kantje van grote loop afhalen}
          and ax,3
          mov laatste_teller,ax

          mov ax,reg_es
          mov es,ax
          mov ax,reg_ds            {NEW!}
         {mov fs,ax}  db $8E,$E0   {NEW!}
          mov ax,reg_ax
          mov bl,reg_bl
          mov bh,reg_bh
          mov dx,reg_dx
          mov si,reg_si
          mov di,reg_di
          mov bp,reg_bp

          cmp eerste_teller,0
          je @skiploop2
         {mov cl,fs:[bx]}  db $64,$8A,$0F
          add dx,ax;sbb bl,0;add si,bp;sbb bh,0
          mov es:[di],cl;inc di;
        @skiploop2:

          cmp drawstretch_teller,0
          je @skiploop0
        @loop0:
         {mov cl,fs:[bx]}  db $64,$8A,$0F
          add dx,ax;sbb bl,0;add si,bp;sbb bh,0
         {mov ch,fs:[bx]}  db $64,$8A,$2F
          add dx,ax;sbb bl,0;add si,bp;sbb bh,0
          mov es:[di],cx;add di,2;
         {mov cl,fs:[bx]}  db $64,$8A,$0F
          add dx,ax;sbb bl,0;add si,bp;sbb bh,0
         {mov ch,fs:[bx]}  db $64,$8A,$2F
          add dx,ax;sbb bl,0;add si,bp;sbb bh,0
          mov es:[di],cx;add di,2;
          dec drawstretch_teller;jnz @loop0
        @skiploop0:

          cmp laatste_teller,0
          je @skiploop1
        @loop1:
         {mov cl,fs:[bx]}  db $64,$8A,$0F
          add dx,ax;sbb bl,0;add si,bp;sbb bh,0
          mov es:[di],cl;inc di;
          dec laatste_teller;jnz @loop1
        @skiploop1:

          mov reg_si,si
          mov reg_bl,bl
          mov reg_bh,bh
          mov reg_di,di
          mov reg_dx,dx
          mov reg_ax,ax

          pop es
          pop si
          pop bp
        end;
end;
procedure writetxt(txt:string;dest_offset:word);
var
  cntr_loc,cntr2_loc:word;
  val_loc:byte;
  letter_ascii:byte;
  source_offset:word;
  let_nr:word;
  seg_from,seg_to:word;
  letter_width,letter_height:word;
begin
  seg_from:=SEG(Blokjesmem^);
  seg_to:=VirscreenBase;
  for let_nr:=0 to length(txt)-1 do begin
    letter_ascii:=ORD(txt[let_nr+1]);
    if stax1[letter_ascii*4]<>65535 then begin
      source_offset:=stax1[letter_ascii*4]+stax1[letter_ascii*4+1]*320;
      letter_width:=stax1[letter_ascii*4+2];
      letter_height:=stax1[letter_ascii*4+3];
      asm
        push es
        mov ax,seg_from
       {mov fs,ax} db $8E,$E0
        mov ax,seg_to
        mov es,ax
        mov si,32000
        add si,source_offset
        mov di,dest_offset

        mov cx,letter_height
      @loop1:
        mov dx,letter_width
        shr dx,1
      @loop2:
       {mov ax,fs:[si]} db $64,$8B,$04
        mov bx,ax  {STORE FOR COMPARE}
        neg ax
        add ax,7*257
        shl ax,1
        add ax,112*257
        cmp bl,0
        je @skip_pix0
        mov es:[di],al
       @skip_pix0:
        cmp bh,0
        je @skip_pix1
        mov es:[di]+1,ah
       @skip_pix1:
        add si,2
        add di,2
        dec dx
        jnz @loop2
        sub si,letter_width
        sub di,letter_width
        add si,320
        add di,320
        dec cx
        jnz @loop1

        pop es
      end;
    end;
    inc(dest_offset,stax1[letter_ascii*4+2]);
  end;
end;
procedure put_star;
begin
{   x1:=(65536*512+trunc(sin(emiel_teller*pi/256)*100*65536)-xcam) DIV 2000; {DIV 2000}
{   y1:=(65536*512+trunc(cos(emiel_teller*pi/200)*100*65536)-ycam) DIV 2000;}
    x1:=(65536*512-xcam) DIV 2000; {DIV 2000}
    y1:=(65536*512-ycam) DIV 2000;
{   x2:=trunc((x1/(4096)*Vx_maal_sprite_hoogte2+y1/(4096)*Vx_maal_sprite_hoogte1)*160*1024);
    z2:=trunc((x1/(4096)*Vx_maal_sprite_hoogte4+y1/(4096)*Vx_maal_sprite_hoogte3)*1024);}
    x2:=trunc((x1/(4*16)*Vx_maal_sprite_hoogte2+y1/(4*16)*Vx_maal_sprite_hoogte1)*160);
    z2:=trunc((x1/(4*16)*Vx_maal_sprite_hoogte4+y1/(4*16)*Vx_maal_sprite_hoogte3)/8);

    if z2>10 then begin
      x3:=(x2-1500000) DIV z2;
      y3:=(65536*64-6000000+trunc(sin(emiel_teller*pi/64)*500000)) DIV z2;
      x4:=(x2+1500000) DIV z2;  {breedte}
      y4:=(65536*64-3000000+trunc(sin(emiel_teller*pi/64)*500000)) DIV z2;

      x3:=x3+160*8;
      x4:=x4+160*8;
      y3:=y3+50*8;
      y4:=y4+50*8;

      if (x4>0) AND (y4>0) AND (x3<320*8) AND (y3<199*8) then begin {te zien?}
        xrico:=32*8*65536 DIV (x4-x3);
        yrico:=32*8*65536 DIV (y4-y3);

        xclip_left:=x3;                     {clip left}
        if x3<0 then xclip_left:=0;
        if (xclip_left and 7)<>0 then begin
          inc(xclip_left,8);
        end;
        xclip_left:=xclip_left shr 3;
        xclip_right:=x4;                    {clip right}
        if x4>320*8 then xclip_right:=320*8;
        xclip_right:=xclip_right shr 3;

        yclip_up:=y3;                       {clip up}
        if y3<0 then yclip_up:=0;
        if (yclip_up and 7)<>0 then begin
          inc(yclip_up,8);
        end;
        yclip_up:=yclip_up shr 3;
        yclip_down:=y4;                     {clip low}
        if y4>200*8 then yclip_down:=200*8;
        yclip_down:=yclip_down shr 3;


        yoffset:=xclip_left+yclip_up*320;

        xsource_offs_prec:=(xclip_left*8-x3)*xrico DIV 8+0*65536;
        ysource_offs_prec:=(yclip_up  *8-y3)*yrico DIV 8+48*65536;
        my_seg:=SEG(blokjesmem^);
        my_seg2:=SEG(tabelmem^);
        asm
          push si
          push bp

          mov ax,VirscreenBase
          mov es,ax
          mov ax,my_seg
         {mov fs,ax} db $8e,$e0
          mov ax,my_seg2
         {mov gs,ax} db $8e,$e8

          mov cx,xclip_right  {niet te klein!}
          sub cx,xclip_left
          cmp cx,0
          jle @quit
          mov cx,yclip_down  {niet te klein!}
          sub cx,yclip_up
          cmp cx,0
          jle @quit


          db $66;mov ax,ds:[offset xrico]  {si=rico PREC}
          mov si,ax                        {ax=rico UNPREC}
          db $66;shr ax,16

          mov cx,yclip_down
          sub cx,yclip_up
          mov ytel,cx
        @loop2:
          mov di,yoffset

          db $66;mov cx,ds:[offset ysource_offs_prec]
          db $66;add cx,ds:[offset yrico]
          db $66;mov ds:[offset ysource_offs_prec],cx
          db $66;shr cx,16
          shl cx,6
          mov bx,cx
          shl cx,2
          add bx,cx

          db $66;mov cx,ds:[offset xsource_offs_prec]
          mov bp,cx
          db $66;shr cx,16
          add bx,cx

          mov cx,xclip_right
          sub cx,xclip_left
        @loop:
          add bp,si
          adc bl,al
          mov dx,bx   {SAVE SOURCE-OFFSET}
         {mov bh,fs:[bx]} db $64,$8A,$3F   {BH:=SOURCE:SOURCE-OFFSET}
          mov bl,es:[di];                  {BL:=DEST:DEST-OFFSET}
         {mov ah,gs:[bx]} db $65,$8A,$27   {AH:=TABEL[BX]}
          mov bx,dx   {LOAD SOURCE-OFFSET}
          cmp ah,0
          je @sk
          mov es:[di],ah;@sk:
          inc di
          dec cx
          jne @loop

          add yoffset,320
          dec ytel
          jne @loop2


        @quit:
          pop bp
          pop si
        end;

      end;
    end;
end;
procedure put_enemy;
begin
{   x1:=(65536*512+trunc(sin(emiel_teller*pi/256)*100*65536)-xcam) DIV 2000; {DIV 2000}
{   y1:=(65536*512+trunc(cos(emiel_teller*pi/200)*100*65536)-ycam) DIV 2000;}
    x1:=(xenemie[enemie_nr]-xcam) DIV 2000; {DIV 2000}
    y1:=(yenemie[enemie_nr]-ycam) DIV 2000;
{   x2:=trunc((x1/(4096)*Vx_maal_sprite_hoogte2+y1/(4096)*Vx_maal_sprite_hoogte1)*160*1024);
    z2:=trunc((x1/(4096)*Vx_maal_sprite_hoogte4+y1/(4096)*Vx_maal_sprite_hoogte3)*1024);}
    x2:=trunc((x1/(4*16)*Vx_maal_sprite_hoogte2+y1/(4*16)*Vx_maal_sprite_hoogte1)*160);
    z2:=trunc((x1/(4*16)*Vx_maal_sprite_hoogte4+y1/(4*16)*Vx_maal_sprite_hoogte3)/8);

    if z2>10 then begin
      x3:=(x2-breedenemie[enemie_nr]) DIV z2;
      y3:=(heightenemie[enemie_nr]-widthenemie[enemie_nr]) DIV z2;
      x4:=(x2+breedenemie[enemie_nr]) DIV z2;  {breedte}
      y4:=(heightenemie[enemie_nr]-0000000) DIV z2;

      x3:=x3+my_breedte;
      x4:=x4+my_breedte;
      y3:=y3+my_hoogte;
      y4:=y4+my_hoogte;


      if (x4>0) AND (y4>0) AND (x3<320*8) AND (y3<199*8) then begin {te zien?}
        xrico:=texturebreed DIV (x4-x3);
        yrico:=texturehoog DIV (y4-y3);

        xclip_left:=x3;                     {clip left}
        if x3<0 then xclip_left:=0;
        if (xclip_left and 7)<>0 then begin
          inc(xclip_left,8);
        end;
        xclip_left:=xclip_left shr 3;
        xclip_right:=x4;                    {clip right}
        if x4>320*8 then xclip_right:=320*8;
        xclip_right:=xclip_right shr 3;

        yclip_up:=y3;                       {clip up}
        if y3<0 then yclip_up:=0;
        if (yclip_up and 7)<>0 then begin
          inc(yclip_up,8);
        end;
        yclip_up:=yclip_up shr 3;
        yclip_down:=y4;                     {clip low}
        if y4>200*8 then yclip_down:=200*8;
        yclip_down:=yclip_down shr 3;


        yoffset:=xclip_left+yclip_up*320;

        xsource_offs_prec:=(xclip_left*8-x3)*xrico DIV 8+my_ofsx;
        ysource_offs_prec:=(yclip_up  *8-y3)*yrico DIV 8+my_ofsy;
        asm
          push si
          push bp

          mov ax,VirscreenBase
          mov es,ax
          mov ax,my_seg
         {mov fs,ax} db $8e,$e0

          mov cx,xclip_right  {niet te klein!}
          sub cx,xclip_left
          cmp cx,0
          jle @quit
          mov cx,yclip_down  {niet te klein!}
          sub cx,yclip_up
          cmp cx,0
          jle @quit


          db $66;mov ax,ds:[offset xrico]  {si=rico PREC}
          mov si,ax                        {dx=rico UNPREC}
          db $66;shr ax,16
          mov dx,ax

          mov cx,yclip_down
          sub cx,yclip_up
          mov ytel,cx
        @loop2:
          mov di,yoffset

          db $66;mov cx,ds:[offset ysource_offs_prec]
          db $66;add cx,ds:[offset yrico]
          db $66;mov ds:[offset ysource_offs_prec],cx
          db $66;shr cx,16
          shl cx,6
          mov bx,cx
          shl cx,2
          add bx,cx

          db $66;mov cx,ds:[offset xsource_offs_prec]
          mov bp,cx
          db $66;shr cx,16
          add bx,cx

          mov cx,xclip_right
          sub cx,xclip_left
        @loop:
          add bp,si
          adc bx,dx
         {mov ah,fs:[bx]} db $64,$8A,$27   {BH:=SOURCE:SOURCE-OFFSET}
          cmp ah,0
          je @sk
          mov es:[di],ah;@sk:
          inc di
          dec cx
          jne @loop

          add yoffset,320
          dec ytel
          jne @loop2


        @quit:
          pop bp
          pop si
        end;

      end;
    end;
end;
procedure calc_tabelmem(mode:byte);
var
  cntr_loc,cntr2_loc:word;
  iter:word;
begin
  iter:=15;
  if mode=0 then iter:=127;
  for cntr2_loc:=0 to iter do begin
    for cntr_loc:=0 to 255 do begin
      mem[SEG(tabelmem^):cntr_loc+(cntr2_loc) shl 8]:=cntr_loc;
    end;
  end;
  for cntr2_loc:=0 to iter do begin
    for cntr_loc:=0 to 255 do begin
      lichter_input:=cntr_loc;
      if mode=0 then begin
        brightness:=cntr2_loc-64;
        lichter;
        mem[SEG(virscreen^):cntr_loc+(cntr2_loc) shl 8]:=lichter_output;
        mem[$a000:cntr_loc+cntr2_loc*320]:=lichter_output;
      end;
      if mode=1 then begin
        brightness:=(15-cntr2_loc)*5;
        lichter2;
        mem[SEG(tabelmem^):cntr_loc+(cntr2_loc+16) shl 8]:=lichter_output;
      end;
    end;
  end;
end;
procedure additional_screen_info;
begin
    damage_value:=damage_long shr 14;
    writetxt('DAMAGE',0);
    for cntr:=0 to 29 do begin  {DAMAGE BOX}
      memw[VirscreenBase:106+6*320+cntr+cntr]:=70*257;
      memw[VirscreenBase:106+10*320+cntr+cntr]:=76*257;
    end;
    for cntr:=0 to 2 do begin   {DAMAGE BOX}
      mem[VirscreenBase:105+7*320+cntr*320]:=70;
      mem[VirscreenBase:106+30*2+7*320+cntr*320]:=76;
    end;
    for cntr:=0 to 2 do begin   {DAMAGE BOX-VULLING}
      for cntr2:=0 to 59 do begin
        if damage_value>=cntr2+1 then
        mem[VirscreenBase:106+7*320+cntr2+cntr*320]:=32;
        if damage_value<cntr2+1 then
        mem[VirscreenBase:106+7*320+cntr2+cntr*320]:=0;
      end;
    end;
    for cntr:=0 to 23 do begin  {DAMAGE LIGHT-EFFECT,UP}
      if damage_value>=cntr+1 then
      mem[VirscreenBase:106+7*320+cntr]:=(48+cntr DIV 4);
      if damage_value<cntr+1 then
      mem[VirscreenBase:106+7*320+cntr]:=(18+cntr DIV 2);
    end;
    if damage_value>0 then begin {DAMAGE LIGHT-EFFECT,LEFT}
      mem[VirscreenBase:106+8*320]:=48;
      mem[VirscreenBase:106+9*320]:=49;
    end;
    if damage_value=0 then begin
      mem[VirscreenBase:106+8*320]:=18;
      mem[VirscreenBase:106+9*320]:=20;
    end;
    writetxt('COACH',224);
    if rank=1 then writetxt('1ST',player_position_x[player_position_xcntr]+player_position_y[player_position_ycntr]);
    if rank=2 then writetxt('2ND',player_position_x[player_position_xcntr]+180*320);
    if rank=3 then writetxt('3RD',16+180*320);
    if rank=4 then writetxt('4TH',16+180*320);
    if rank=5 then writetxt('5TH',16+180*320);
    if rank=6 then writetxt('6TH',16+180*320);
    if rank=7 then writetxt('7TH',16+180*320);
    if rank=8 then writetxt('8TH',16+180*320);
    if rank=9 then writetxt('9TH',16+180*320);
    inc(player_position_xcntr);
    if player_position_xcntr=72 then player_position_xcntr:=0;
    inc(player_position_ycntr);
    if player_position_ycntr=40 then player_position_ycntr:=0;
end;