procedure setpal(c,r,g,b:byte); assembler; asm
  mov dx,3c8h; mov al,[c]; out dx,al; inc dx; mov al,[r]
  out dx,al; mov al,[g]; out dx,al; mov al,[b]; out dx,al; end;

procedure SetGraphics(Mode : byte); assembler;
asm mov AH,0;mov AL,Mode;int 10h;end;

procedure retrace; assembler; asm
  mov dx,3dah; @vert1: in al,dx; test al,8; jz @vert1
  @vert2: in al,dx; test al,8; jnz @vert2; end;
{A 640x480x256 vesa test by Jack}
{Video Modes:
101h    640x480x256
103h    800x600x256
105h    1024x768x256
110h    640x480x32k (?)
}
var
  X, Y : Word;
  Current_Bank : Word;

procedure setmode (mode : word); assembler;
asm
  mov ax,4F02h
  mov bx,mode
  int 10h
end;

procedure setbank(bank:word);assembler;
asm
  mov ax, 4f05h
  mov bx, 0h
  mov dx, bank
  mov Current_Bank, dx
  int 10h
end;

procedure setpix(x,y,col:word);assembler;
var  decalage:word;
      asm
 mov bx,x
 mov ax,y {removed all range checking on x,y for speed}
 mov cx, 1280
 mul cx {640 bytes wide in most cases}
 add bx,ax
{ adc dx,0}
 mov ax, dx { what a $#%%# stupid microprocessor}
 adc ax, 0

  {mov provi,al}   { bank  }
  mov decalage,bx
  cmp ax,Current_Bank
  jz @nonew
  mov ah,0
  push cs
  push ax
  call setbank   { here ax = bank }
  @nonew:

  mov bx,col
  mov ax,sega000
  mov es,ax
  mov di,decalage
  mov [es:di],bl
end;
procedure copy_screen;
var
  coldark:byte;
begin
  coldark:=0;
  asm
    push ds
    push si
    mov ax,VirScreenBase;
    mov es,ax
    mov ax,sega000
    mov ds,ax
    mov si,0
    mov cx,4000
    db $66;xor ax,ax
    mov bl,coldark
    mov bh,bl
    mov ax,bx
    db $66;shl ax,16
    mov ax,bx
  @loop:
    db $66;mov bx,es:[si]
    db $66;mov ds:[si],bx
    add si,4
    db $66;mov bx,es:[si]
    db $66;mov ds:[si],bx
    add si,4
    db $66;mov bx,es:[si]
    db $66;mov ds:[si],bx
    add si,4
    db $66;mov bx,es:[si]
    db $66;mov ds:[si],bx
    add si,4
    dec cx
    jnz @loop
    pop si
    pop ds
  end;
end;
procedure copy_screen_echo;
var
  coldark:word;
begin
  coldark:=teller AND 1;
  asm
    push ds
    push si
    mov ax,VirScreenBase;
    mov es,ax
    mov ax,sega000
    mov ds,ax
    mov si,0
    mov ch,200
  @loop2:
    mov ax,coldark
    inc ax
    and ax,1
    mov coldark,ax
    mov cl,40
    db $66;xor ax,ax
    add si,coldark
    mov ax,bx
    db $66;shl ax,16
    mov ax,bx
  @loop:
    mov bl,es:[si]
    mov ds:[si],bl
    add si,2
    mov bl,es:[si]
    mov ds:[si],bl
    add si,2
    mov bl,es:[si]
    mov ds:[si],bl
    add si,2
    mov bl,es:[si]
    mov ds:[si],bl
    add si,2
    dec cl
    jnz @loop
    sub si,coldark
    dec ch
    jnz @loop2
    pop si
    pop ds
  end;
end;
procedure cls_virscreen;
begin
    asm
      mov ax,virscreenbase
      mov es,ax
      mov di,0
      mov cx,200*160
      mov ax,0{31*257}
     @l:
      mov es:[di],ax
      add di,2
      dec cx
      jnz @l
    end;
end;
procedure copy_sourcemem4_virscreen;
begin
  my_seg:=segSourcememarray[4];
    asm
      mov ax,virscreenbase
      mov es,ax
      mov ax,my_seg
     {mov fs,ax} db $8e,$e0
      mov di,0
      mov cx,200*160
     @l:
     {mov ax,fs:[di]} db $64,$8B,$05
      mov es:[di],ax
      add di,2
      dec cx
      jnz @l
    end;
end;
procedure box(x1,y1,x2,y2:integer);
var
  xb,yb,xe,ye:integer;
begin
  Debug_string:='Procedure BOX(SCREEN.INC)';
  if (x1<320) AND (x2>0) AND (y1<200) AND (y2>0) then begin
    xb:=x1;
    if xb<0 then xb:=0;
    yb:=y1;
    if yb<0 then yb:=0;
    xe:=x2;
    if xe>319 then xe:=319;
    ye:=y2;
    if ye>199 then ye:=199;
    for cntr2:=yb to ye do begin
      cntr3:=cntr2*320;
      for cntr:=xb to xe do begin
        mem[Virscreenbase:cntr+cntr3]:=0;
      end;
    end;
  end;
end;
procedure getfont; assembler; asm
  mov ax,1130h; mov bh,6; int 10h; mov fseg,es; mov fofs,bp; end;
procedure writepc(x,y:word; txt:string);
var i,j,k:byte;
begin
{ for i:=1 to length(txt) do for j:=0 to 15 do for k:=0 to 7 do
    if ((mem[fseg:fofs+ord(txt[i])*16+j] shl k) and 128) <> 0 then begin
      mem[sega000:(i*8+x+k-7)+(y+j+1)*320]:=0;
      mem[sega000:(i*8+x+k-8)+(y+j  )*320]:=128+j+k;
    end;}
end;
procedure writetxt(txt:string;dest_offset:word);
var
  cntr_loc,cntr2_loc:word;
  val_loc:byte;
  letter_ascii:byte;
  source_offset:word;
  let_nr:word;
  seg_from,seg_to:word;
  letter_width,letter_height:word;
begin
  Debug_string:='Procedure WRITETXT(SCREEN.INC)';

  seg_from:=SEG(Blokjesmem^);
  seg_to:=VirscreenBase;
  for let_nr:=0 to length(txt)-1 do begin
    letter_ascii:=ORD(txt[let_nr+1]);
    if stax1[letter_ascii*4]<>65535 then begin
      source_offset:=stax1[letter_ascii*4]+stax1[letter_ascii*4+1]*320;
      letter_width:=stax1[letter_ascii*4+2];
      letter_height:=stax1[letter_ascii*4+3];
      asm
        push es
        mov ax,seg_from
       {mov fs,ax} db $8E,$E0
        mov ax,seg_to
        mov es,ax
        mov si,32000
        add si,source_offset
        mov di,dest_offset

        mov cx,letter_height
      @loop1:
        mov dx,letter_width
        shr dx,1
      @loop2:
       {mov ax,fs:[si]} db $64,$8B,$04
        mov bx,ax  {STORE FOR COMPARE}
        neg ax
        add ax,7*257
        shl ax,1
        add ax,112*257
        cmp bl,0
        je @skip_pix0
        mov es:[di],al
       @skip_pix0:
        cmp bh,0
        je @skip_pix1
        mov es:[di]+1,ah
       @skip_pix1:
        add si,2
        add di,2
        dec dx
        jnz @loop2
        sub si,letter_width
        sub di,letter_width
        add si,320
        add di,320
        dec cx
        jnz @loop1

        pop es
      end;
    end;
    inc(dest_offset,stax1[letter_ascii*4+2]);
  end;
end;
