{
  Optic|
  -----~

  This programme demonstrates how to convert from RGB to HSV and back.

  RGB
  ---
  Red
   Green
    Blue

  HSV
  ---
  Hue         (color-type Red,Yellow,Green etc.)
   Saturation (how much color)
    Volume    (the intensity)

  from RGB to HSV
  ---------------
  highest:=highest value from R,G,B
  lowest :=lowest value  from R,G,B

  * V:=highest
  * S:=(highest-lowest)/highest*255

  (look at range between lowest and highest for the Hue)
  R':=(r-lowest)*255/(highest-lowest)
  G':=(r-lowest)*255/(highest-lowest)
  B':=(r-lowest)*255/(highest-lowest)
  * convert R',G' and B' to H

  from HSV to RGB
  ---------------
  look at the H and get a R' G' and B' with each value in a range of 0-255
  highest:=V;
  lowest:=highest-(S/255*highest);
  r:=r/255*(highest-lowest)+lowest;
  g:=g/255*(highest-lowest)+lowest;
  b:=b/255*(highest-lowest)+lowest;
}
program landscap;
uses crt;
var
  cntr:word;
  r,g,b,h,s,v:real;
  hoogste,laagste:real;
  kleur_eruit,kleur_second,kleur_top:byte;
function RealToStr(I: real): String; { Convert any real to a string }
var
 S: string[11];
 D,V:real;
 int:longint;
 maal:word;
begin
 d:=1;
 if i<1000 then d:=100;
 if i<100 then d:=10;
 if i<10 then d:=1;

 S:='';
 for maal:=0 to 7 do begin
   Int:=trunc(I/D) mod 10;
   I:=I-Int*D;
   S:=S+CHR(Int+48);
   if D=1 then S:=S+'.';
   D:=D/10;
 end;
 RealToStr := S;
end;

procedure convertRGB2H2RGB;
begin
  hoogste:=r; {hoogste van R,G en B}
  if hoogste<g then hoogste:=g;
  if hoogste<b then hoogste:=b;
  laagste:=r; {laagste van R,G en B}
  if laagste>g then laagste:=g;
  if laagste>b then laagste:=b;

  v:=hoogste;
  s:=(hoogste-laagste)*255/hoogste;
  if laagste<hoogste then begin             {recovering RGB}
    r:=(r-laagste)*255/(hoogste-laagste);
    g:=(g-laagste)*255/(hoogste-laagste);
    b:=(b-laagste)*255/(hoogste-laagste);
  end;
end;
procedure convertRGB2HSV;
begin
  hoogste:=r; {hoogste van R,G en B}
  if hoogste<g then hoogste:=g;
  if hoogste<b then hoogste:=b;
  laagste:=r; {laagste van R,G en B}
  if laagste>g then laagste:=g;
  if laagste>b then laagste:=b;

  v:=hoogste;
  s:=(hoogste-laagste)*255/hoogste;
  if laagste<hoogste then begin             {recovering RGB}
    r:=(r-laagste)*255/(hoogste-laagste);
    g:=(g-laagste)*255/(hoogste-laagste);
    b:=(b-laagste)*255/(hoogste-laagste);
    if r=0 then kleur_eruit:=0;
    if g=0 then kleur_eruit:=1;
    if b=0 then kleur_eruit:=2;
    if r=255 then kleur_top:=0;
    if g=255 then kleur_top:=1;
    if b=255 then kleur_top:=2;
    if (kleur_eruit<>0) AND (kleur_top<>0) then kleur_second:=0;
    if (kleur_eruit<>1) AND (kleur_top<>1) then kleur_second:=1;
    if (kleur_eruit<>2) AND (kleur_top<>2) then kleur_second:=2;
    if (kleur_top=0) then begin        {r=100             }
      if (kleur_second=1) then begin   {r=100 g=?   b=0   van h=0 -> h=100/7}
        h:=0+(g/255)*256/6;
      end;
      if (kleur_second=2) then begin   {r=100 g=0   b=?   van h=100 -> h=100*5/7}
        h:=256-(b/255)*256/6;
      end;
    end;
    if (kleur_top=1) then begin        {      g=100       }
      if (kleur_second=0) then begin   {r=?   g=100 b=0   van h=100*2/7 -> h=100/7}
        h:=256*2/6-(r/255)*256/6;
      end;
      if (kleur_second=2) then begin   {r=0   g=100 b=?   van h=100*2/7 -> h=100*3/7}
        h:=256*2/6+(b/255)*256/6;
      end;
    end;
    if (kleur_top=2) then begin        {            b=100 }
      if (kleur_second=0) then begin   {r=?   g=0   b=100 van h=100*4/7 -> h=100*5/7}
        h:=256*4/6+(r/255)*256/6;
      end;
      if (kleur_second=1) then begin   {r=0   g=?   b=100 van h=100*4/7 -> h=100*3/7}
        h:=256*4/6-(g/255)*256/6;
      end;
    end;
  end else begin
    h:=0;
  end;
end;

procedure convertHSV2RGB;
begin
  if (h>=0) AND (h<256/6) then begin
    r:=255;
    g:=255*h/(256/6);
    b:=0;
  end;
  if (h>=256/6) AND (h<256*2/6) then begin
    r:=255-255*(h-256/6)/(256/6);
    g:=255;
    b:=0;
  end;
  if (h>=256*2/6) AND (h<256*3/6) then begin
    r:=0;
    g:=255;
    b:=255*(h-256*2/6)/(256/6);
  end;
  if (h>=256*3/6) AND (h<256*4/6) then begin
    r:=0;
    g:=255-255*(h-256*3/6)/(256/6);
    b:=255;
  end;
  if (h>=256*4/6) AND (h<256*5/6) then begin
    b:=255;
    g:=0;
    r:=255*(h-256*4/6)/(256/6);
  end;
  if (h>=256*5/6) AND (h<256*6/6) then begin
    b:=255-255*(h-256*5/6)/(256/6);
    g:=0;
    r:=255;
  end;
  hoogste:=v;
  laagste:=hoogste-(s/255*hoogste);
  r:=r/255*(hoogste-laagste)+laagste;
  g:=g/255*(hoogste-laagste)+laagste;
  b:=b/255*(hoogste-laagste)+laagste;
end;

begin
  for cntr:=0 to 100 do writeln;
  gotoxy(1,1);
  r:=255*78 DIV 100;
  g:=255*61 DIV 100;
  b:=255*13 DIV 100;
{ r:= 50; g:= 61; b:= 50;}

  writeln('RGB->HSV');
  writeln('--------------');
  write('R:');write(trunc(r));
  write(' G:');write(trunc(g));
  write(' B:');writeln(trunc(b));
  convertRGB2HSV;
  write('H:');write(trunc(h));
  write(' S:');write(trunc(s));
  write(' V:');writeln(trunc(v));

{ h:=  256*2/6; s:=  0; v:=255;}
  writeln;
  writeln('RGB<-HSV');
  writeln('--------------');
  write('H:');write(trunc(h));
  write(' S:');write(trunc(s));
  write(' V:');writeln(trunc(v));
  convertHSV2RGB;
  write('R:');write(trunc(r));
  write(' G:');write(trunc(g));
  write(' B:');write(trunc(b));
  write('   ');
  readkey;
end.