
{$N-}

program Rotation;
{ 3d rotating plane, uses slow math somewhere, by Bas van Gaalen, Holland, PD }
{ SVGABGI... }
uses
  dos,crt,graph;

const
  ScrBase : word = $a000;
  NofPoints = 2;
  Speed = 1;
  Xc : word = 0;
  Yc : word = 0;
  Zc : word = 200;
  SinTab : array[0..255] of integer = (
    0,3,6,9,13,16,19,22,25,28,31,34,37,40,43,46,49,52,55,58,60,63,66,68,
    71,74,76,79,81,84,86,88,91,93,95,97,99,101,103,105,106,108,110,111,
    113,114,116,117,118,119,121,122,122,123,124,125,126,126,127,127,127,
    128,128,128,128,128,128,128,127,127,127,126,126,125,124,123,122,122,
    121,119,118,117,116,114,113,111,110,108,106,105,103,101,99,97,95,93,
    91,88,86,84,81,79,76,74,71,68,66,63,60,58,55,52,49,46,43,40,37,34,31,
    28,25,22,19,16,13,9,6,3,0,-3,-6,-9,-13,-16,-19,-22,-25,-28,-31,-34,
    -37,-40,-43,-46,-49,-52,-55,-58,-60,-63,-66,-68,-71,-74,-76,-79,-81,
    -84,-86,-88,-91,-93,-95,-97,-99,-101,-103,-105,-106,-108,-110,-111,
    -113,-114,-116,-117,-118,-119,-121,-122,-122,-123,-124,-125,-126,
    -126,-127,-127,-127,-128,-128,-128,-128,-128,-128,-128,-127,-127,
    -127,-126,-126,-125,-124,-123,-122,-122,-121,-119,-118,-117,-116,
    -114,-113,-111,-110,-108,-106,-105,-103,-101,-99,-97,-95,-93,-91,
    -88,-86,-84,-81,-79,-76,-74,-71,-68,-66,-63,-60,-58,-55,-52,-49,
    -46,-43,-40,-37,-34,-31,-28,-25,-22,-19,-16,-13,-9,-6,-3);

type
  PointRec = record
               X,Y,Z : integer;
             end;
  PointPos = array[0..NofPoints] of PointRec;

var
  Point : PointPos;
  Color:byte;

{----------------------------------------------------------------------------}

procedure SetGraphics;
var GrMd,GrDr : integer;

{$F+} function DetectVGA : Integer; begin DetectVGA := 2; end; {$F-}

begin
{  InstallUserDriver('SVGA256',@DetectVGA); GrDr := 0;
  InitGraph(GrDr,GrMd,'D:\turbo\bgi');}
  asm mov AH,0;mov AL,13h;int 10h;end;
end;

procedure Line(X1,Y1,X2,Y2 : integer); assembler;

const XInc : integer = 1; OffS : word = $140;
var Incr2 : integer;

asm
  mov ax,Y1; mov cx,Y2; sub cx,ax; je @Hline;
  mov bx,X2; mov dx,X1; sub bx,dx; je @VLine;
  sub ax,Y2; cwd; xor ax,dx; sub ax,dx; mov si,dx; mov cx,ax
  mov ax,X1; sub ax,X2; cwd; xor ax,dx; sub ax,dx; cmp ax,cx
  jl @YLine; jmp @XLine
 @HLine:
  mov es,ScrBase; mov dx,X1; mov cx,X2; cmp dx,cx; jle @HContinue; xchg dx,cx
 @HContinue:
  sub cx,dx; mov di,dx; xchg ah,al; add di,ax; shr ax,1; shr ax,1
  add di,ax; inc cx; mov al,Color; rep stosb; jmp @Exit
 @VLine:
  mov es,ScrBase; cmp cx,0; jg @VContinue; neg cx; mov ax,Y2
 @VContinue:
  inc cx; mov di,dx; xchg ah,al; add di,ax; shr ax,1
  shr ax,1; add di,ax; mov al,Color
 @VRunLoop:
  mov es:[di],al; add di,140h; loop @VRunLoop; jmp @Exit
 @YLine:
  mov es,ax; sub ax,cx; shl ax,1; mov sp,ax; mov XInc,1; mov ax,es
  shl ax,1; mov bx,ax; sub bx,cx; cmp si,-1; je @Y2greaterY1
 @Y1greaterY2:
  mov si,ax; mov ax,X2; cmp dx,-1; mov dx,Y2; je @YNeg; jmp @YContinue
 @Y2greaterY1:
  mov si,ax; mov ax,X1; cmp dx,0; mov dx,Y1; je @YNeg; jmp @YContinue
 @YNeg:
  neg XInc
 @YContinue:
  mov di,ax; xchg dh,dl; add di,dx; shr dx,1; shr dx,1
  add di,dx; mov ah,Color; mov es,ScrBase; inc cx
 @YRunLoop:
  mov es:[di],ah; add di,140h; cmp bx,0; jl @YNoInc; add bx,sp
  add di,XInc; jmp @YCheck
 @YNoInc:
  add bx,si
 @YCheck:
  loop @YRunLoop; jmp @Exit
 @XLine:
  cmp dx,-1; jle @X2greaterX1
  mov bx,X2; mov dx,Y2; cmp si,-1; mov si,140h; je @XNeg; jmp @XContinue
 @X2greaterX1:
  mov bx,X1; mov dx,Y1; cmp si,-1; mov si,140h; jne @XNeg; jmp @XContinue
 @XNeg:
  neg si
 @XContinue:
  mov di,bx; xchg dh,dl; add di,dx; shr dx,1; shr dx,1; add di,dx
  mov sp,cx; sub sp,ax; shl sp,1; mov bx,cx; shl bx,1; mov OffS,si
  mov si,bx; sub bx,ax; mov cx,ax; mov es,ScrBase; mov ah,Color; inc cx
 @XRunLoop:
  mov es:[di],ah; inc di; cmp bx,0; jl @XNoInc; add bx,sp; add di,OffS; jmp @XCheck
 @XNoInc:
  add bx,si
 @XCheck:
  loop @XRunLoop
 @Exit:
end;

{----------------------------------------------------------------------------}

procedure Init;

var
  x,y,z : integer; i : byte;

begin
{  randomize;
  for I := 0 to NofPoints do begin
    Point[I].X := random(300)-150;
    Point[I].Y := random(300)-150;
    Point[I].Z := random(300)-150;
  end;}
{
  i := 0;
  z := 0;
  for y :=0 to 0 do begin
    x := 0;
    for x :=0 to 32 do begin
      point[i].x := (x-16)*10;
      point[i].y := 100;
      point[i].z := 0;
      inc(i);
    end;
  end;
}
  point[0].x :=190;
  point[0].y :=0;
  point[0].z :=0;
  point[1].x :=0;
  point[1].y :=190;
  point[1].z :=0;
  point[2].x :=0;
  point[2].y :=0;
  point[2].z :=190;

  for I := 1 to 63 do begin
    port[$3C8] := I;
    x:=I*2;
    if x>63 then x:=63;
    port[$3C9] := x;
    port[$3C9] := x;
    port[$3C9] := x;
  end;
   port[$3C8] := 64;
  port[$3C9] := 48;
  port[$3C9] := 0;
  port[$3C9] := 0;
   port[$3C8] := 65;
  port[$3C9] := 63;
  port[$3C9] := 32;
  port[$3C9] := 32;

   port[$3C8] := 66;
  port[$3C9] := 0;
  port[$3C9] := 48;
  port[$3C9] := 0;
   port[$3C8] := 67;
  port[$3C9] := 32;
  port[$3C9] := 63;
  port[$3C9] := 32;

   port[$3C8] := 68;
  port[$3C9] := 0;
  port[$3C9] := 0;
  port[$3C9] := 48;
   port[$3C8] := 69;
  port[$3C9] := 32;
  port[$3C9] := 32;
  port[$3C9] := 63;
end;
procedure putpixel(Xpos,Ypos,col:word);
begin
  mem[$a000:Xpos+Ypos*320]:=col;
end;
{----------------------------------------------------------------------------}

function Sinus(Idx : byte) : integer; begin
  Sinus := SinTab[Idx]; end;

{----------------------------------------------------------------------------}

function Cosin(Idx : byte) : integer; begin
  Cosin := SinTab[(Idx+192) mod 255]; end;

{----------------------------------------------------------------------------}

procedure Rotate;       {BEREKEN DE 3D-VECTOREN VOOR DE X,Y EN Z , GA NIET LANGS START}

const
  Xstep = 1;
  Ystep = 1;
  Zstep = 0;

var
  Xp,Yp : array[0..NofPoints] of word;
  X,Y,Z,X1,Y1,Z1 : integer;
  v,I : word;
  PhiX,PhiY,PhiZ : byte;

begin
  PhiX := 40; PhiY := 70; PhiZ := 20;
  repeat
    while (port[$3da] and 8) <> 8 do;
    while (port[$3da] and 8) = 8 do;
    port[$3c8] := 0; port[$3c9] := 20; port[$3c9] := 0; port[$3c9] := 0;
    for I := 0 to NofPoints do begin
      color:=0;
      if (Xp[I] < 320) and (Yp[I] < 200) then
      begin
        line(287,33,Xp[i],Yp[i]);
      end;
      X1 := (Cosin(PhiY)*Point[I].X-Sinus(PhiY)*Point[I].Z) div 128;
      Y1 := (Cosin(PhiZ)*Point[I].Y-Sinus(PhiZ)*X1) div 128;
      Z1 := (Cosin(PhiY)*Point[I].Z+Sinus(PhiY)*Point[I].X) div 128;
      X  := (Cosin(PhiZ)*X1+Sinus(PhiZ)*Point[I].Y) div 128;
      Y  := (Cosin(PhiX)*Y1+Sinus(PhiX)*Z1) div 128;
      Z  := (Cosin(PhiX)*Z1-Sinus(PhiX)*Y1) div 128;
      Xp[I] := 287+(Xc*Z-X*Zc) div (Z-1000-Zc);
      Yp[I] :=  33+(Yc*Z-Y*Zc) div (Z-1000-Zc);
      if (Xp[I] < 320) and (Yp[I] < 200) then
      begin
        color:=64+i*2+(Z+200) DIV 210; {Z=-200 ,Z+200=0   ; Z=200 , Z+200=400}
        line(287,33,Xp[i],Yp[i]);
      end;
    end;
    inc(PhiX,Xstep);
    inc(PhiY,Ystep);
    inc(PhiZ,Zstep);
    port[$3c8] := 0; port[$3c9] := 0; port[$3c9] := 0; port[$3c9] := 0;

  until keypressed;
end;

{----------------------------------------------------------------------------}

begin
  SetGraphics;
  Init;
  Rotate;
  {textmode(lastmode);}
end.
