
{$N-}

program Rotation;
{ 3d rotating plane, uses slow math somewhere, by Bas van Gaalen, Holland, PD }
{ SVGABGI... }
uses
  dos,crt,graph;

const
  NofPoints = 800; {400}
  Speed = 1;
  Xc : word = 0;
  Yc : word = 0;
  Zc : word = 200;
  TabLen = 2000*2;
  SinTab : array[0..255] of integer = (
    0,3,6,9,13,16,19,22,25,28,31,34,37,40,43,46,49,52,55,58,60,63,66,68,
    71,74,76,79,81,84,86,88,91,93,95,97,99,101,103,105,106,108,110,111,
    113,114,116,117,118,119,121,122,122,123,124,125,126,126,127,127,127,
    128,128,128,128,128,128,128,127,127,127,126,126,125,124,123,122,122,
    121,119,118,117,116,114,113,111,110,108,106,105,103,101,99,97,95,93,
    91,88,86,84,81,79,76,74,71,68,66,63,60,58,55,52,49,46,43,40,37,34,31,
    28,25,22,19,16,13,9,6,3,0,-3,-6,-9,-13,-16,-19,-22,-25,-28,-31,-34,
    -37,-40,-43,-46,-49,-52,-55,-58,-60,-63,-66,-68,-71,-74,-76,-79,-81,
    -84,-86,-88,-91,-93,-95,-97,-99,-101,-103,-105,-106,-108,-110,-111,
    -113,-114,-116,-117,-118,-119,-121,-122,-122,-123,-124,-125,-126,
    -126,-127,-127,-127,-128,-128,-128,-128,-128,-128,-128,-127,-127,
    -127,-126,-126,-125,-124,-123,-122,-122,-121,-119,-118,-117,-116,
    -114,-113,-111,-110,-108,-106,-105,-103,-101,-99,-97,-95,-93,-91,
    -88,-86,-84,-81,-79,-76,-74,-71,-68,-66,-63,-60,-58,-55,-52,-49,
    -46,-43,-40,-37,-34,-31,-28,-25,-22,-19,-16,-13,-9,-6,-3);

type
  PointRec = record
               X,Y,Z : integer;
             end;
  PointPos = array[0..NofPoints] of PointRec;

var
  Point : PointPos;
  TabFile : text;
  Table : array[0..TabLen] of integer;

{----------------------------------------------------------------------------}

procedure SetGraphics;
var GrMd,GrDr : integer;

{$F+} function DetectVGA : Integer; begin DetectVGA := 2; end; {$F-}

begin
  InstallUserDriver('SVGA256',@DetectVGA); GrDr := 0;
  InitGraph(GrDr,GrMd,'D:\turbo\bgi');
end;

{----------------------------------------------------------------------------}
procedure schrijfdisk;

var
  maal : word;

begin
  clrscr;
  write(TabFile,'       dw      ');
  for maal := 0 to TabLen do begin
    if maal mod 40 <>39 then
    begin
      write(TabFile,Table[maal],',');
    end
    else
    begin
      write(TabFile,Table[maal]);
      writeln(TabFile);
      write(TabFile,'       dw      ');
    end;
  end;
end;

{----------------------------------------------------------------------------}

procedure Init;

var
  x,y,z : integer; i : byte;

begin
  for I := 1 to 63 do begin
    port[$3C8] := I;
    port[$3C9] := I;
    port[$3C9] := I;
    port[$3C9] := I;
  end;
end;

{----------------------------------------------------------------------------}

function Sinus(Idx : byte) : integer; begin
  Sinus := SinTab[Idx]; end;

{----------------------------------------------------------------------------}

function Cosin(Idx : byte) : integer; begin
  Cosin := SinTab[(Idx+192) mod 255]; end;

{----------------------------------------------------------------------------}

procedure Rotate;

const
  Xstep = 0;
  Ystep = 1;
  Zstep = 0;

var
  Xp,Yp : array[0..NofPoints] of integer;
  X,Y,Z : integer;
  tel,v,I : word;

begin
  Z := -2000; {-500}
  tel := 0;
  repeat

{-VSYNC-}
{    while (port[$3da] and 8) <> 8 do;
     while (port[$3da] and 8) = 8 do;}

   port[$3c8] := 0;
   port[$3c9] := trunc(Z*64/501);
   port[$3c9] := 0;
   port[$3c9] := 0;

   v :=0;
   for I := 0 to NofPoints do begin

      if (Xp[I] < 640) and (Yp[I] < 480) then
      begin
        putpixel(Xp[I]+320,Yp[I]+240,0);
      end;

      X := trunc((I)*3);
      Y := 50;
      Xp[I] := (Xc*Z-X*Zc) div (Z-Zc);
      Yp[I] := (Yc*Z-Y*Zc) div (Z-Zc);

      if (Xp[I] < 320) and (Yp[I] < 240) then
      begin
        if ((xp[i]<-160) or (xp[i]>160)) or ((yp[i]<-100) or (yp[i]>100)) then
        begin
          putpixel(Xp[I]+320,Yp[I]+240,88);
        end
        else
        begin
          putpixel(Xp[I]+320,Yp[I]+240,63);
          v := i;
        end;
      end;

  end;
  table[tel] :=xp[v];
  table[tel+1] :=v;
  putpixel(Xp[v]+320,(tel DIV 2) mod 480,63);
  putpixel(v,(tel DIV 2) mod 480,63);
  putpixel(trunc(100*xp[v]/v),(tel DIV 2) mod 480,32);
  tel :=tel+2;
  Z := Z+1;
  until keypressed or (Z=0);  {Z=101}
end;

{----------------------------------------------------------------------------}

begin
  assign(TabFile,'D:\TURBO\ASM\XQT3DTAB.DAT');
  rewrite(TabFile);
  SetGraphics;
  Init;
  Rotate;
  schrijfdisk;
  close(TabFile);
  {textmode(lastmode);}
end.
