program Rotation;
uses
  dos,crt,graph;

const
  ScrBase : word = $a000;
  NofPoints = 2;
  Speed = 1;
  Xc : word = 0;
  Yc : word = 0;
  Zc : word = 200;

type
  PointRec = record             { PUNTEN VOOR DE ROTATIE-VECTOREN }
               X,Y,Z : integer;
             end;
  PointPos = array[0..NofPoints] of PointRec;

var
  SinTab : array[0..2047] of integer;
  Point : PointPos;
  Color:byte;

  POINTS_BEFORE : array [0..500*3] of longint;
  POINTS_AFTER3D: array [0..500*3] of longint;
  POINTS_AFTER2D: array [0..500*3] of longint;

  Xp,Yp : array[0..NofPoints] of word;
  X,Y,Z,X1,Y1,Z1 : integer;
  v,i3 : word;
  PhiX,PhiY,PhiZ : integer;
  XROT_X,XROT_Y,XROT_Z:integer;
  YROT_X,YROT_Y,YROT_Z:integer;
  ZROT_X,ZROT_Y,ZROT_Z:integer;
  Mx,My,Mz:word;
  eyedistZ:integer;
  i:integer;
{----------------------------------------------------------------------------}

procedure SetGraphics;
var GrMd,GrDr : integer;

{$F+} function DetectVGA : Integer; begin DetectVGA := 2; end; {$F-}

begin
  asm mov AH,0;mov AL,13h;int 10h;end;
  DirectVideo:=False;           { WriteLn works in GrafiX mode Now }
end;
{----------------------------------------------------------------------------}

function Sinus(Idx : word) : integer; begin
  Sinus := SinTab[Idx mod 2048]; end;

{----------------------------------------------------------------------------}

function Cosin(Idx : word) : integer; begin
  Cosin := SinTab[(Idx+192*8) mod 2048]; end;

{----------------------------------------------------------------------------}
procedure calcpoints(first,last:word);
var
  i,i3:word;
begin
    for i:=first to last do begin
      i3:=i*3;
      POINTS_AFTER3D[i3+2]:=
      (((POINTS_BEFORE[i3]-MX)*ZROT_X)+((POINTS_BEFORE[i3+1]-my)*ZROT_Y)+((POINTS_BEFORE[i3+2]-mz)*ZROT_Z)) div 128;
      if POINTS_AFTER3D[i3+2]>-eyedistZ then begin
        POINTS_AFTER3D[i3]:=(((POINTS_BEFORE[i3]-MX)*XROT_X)
        +((POINTS_BEFORE[i3+1]-my)*XROT_Y)+((POINTS_BEFORE[i3+2]-mz)*XROT_Z));
        POINTS_AFTER3D[i3+1]:=(((POINTS_BEFORE[i3]-MX)*YROT_X)
        +((POINTS_BEFORE[i3+1]-my)*YROT_Y)+((POINTS_BEFORE[i3+2]-mz)*YROT_Z));

        POINTS_AFTER2D[i3]  :=POINTS_AFTER3D[i3]   div (POINTS_AFTER3D[i3+2]+eyedistZ);
        POINTS_AFTER2D[i3+1]:=POINTS_AFTER3D[i3+1] div (POINTS_AFTER3D[i3+2]+eyedistZ);
      end
      else begin
        POINTS_AFTER2D[i3]:=0;
        POINTS_AFTER2D[i3+1]:=0;
        POINTS_AFTER3D[i3]:=0;
        POINTS_AFTER3D[i3+1]:=0;
      end;
    end;
end;

procedure Line(X1,Y1,X2,Y2 : integer); assembler;

const XInc : integer = 1; OffS : word = $140;
var Incr2 : integer;

asm
  mov ax,Y1; mov cx,Y2; sub cx,ax; je @Hline;
  mov bx,X2; mov dx,X1; sub bx,dx; je @VLine;
  sub ax,Y2; cwd; xor ax,dx; sub ax,dx; mov si,dx; mov cx,ax
  mov ax,X1; sub ax,X2; cwd; xor ax,dx; sub ax,dx; cmp ax,cx
  jl @YLine; jmp @XLine
 @HLine:
  mov es,ScrBase; mov dx,X1; mov cx,X2; cmp dx,cx; jle @HContinue; xchg dx,cx
 @HContinue:
  sub cx,dx; mov di,dx; xchg ah,al; add di,ax; shr ax,1; shr ax,1
  add di,ax; inc cx; mov al,Color; rep stosb; jmp @Exit
 @VLine:
  mov es,ScrBase; cmp cx,0; jg @VContinue; neg cx; mov ax,Y2
 @VContinue:
  inc cx; mov di,dx; xchg ah,al; add di,ax; shr ax,1
  shr ax,1; add di,ax; mov al,Color
 @VRunLoop:
  mov es:[di],al; add di,140h; loop @VRunLoop; jmp @Exit
 @YLine:
  mov es,ax; sub ax,cx; shl ax,1; mov sp,ax; mov XInc,1; mov ax,es
  shl ax,1; mov bx,ax; sub bx,cx; cmp si,-1; je @Y2greaterY1
 @Y1greaterY2:
  mov si,ax; mov ax,X2; cmp dx,-1; mov dx,Y2; je @YNeg; jmp @YContinue
 @Y2greaterY1:
  mov si,ax; mov ax,X1; cmp dx,0; mov dx,Y1; je @YNeg; jmp @YContinue
 @YNeg:
  neg XInc
 @YContinue:
  mov di,ax; xchg dh,dl; add di,dx; shr dx,1; shr dx,1
  add di,dx; mov ah,Color; mov es,ScrBase; inc cx
 @YRunLoop:
  mov es:[di],ah; add di,140h; cmp bx,0; jl @YNoInc; add bx,sp
  add di,XInc; jmp @YCheck
 @YNoInc:
  add bx,si
 @YCheck:
  loop @YRunLoop; jmp @Exit
 @XLine:
  cmp dx,-1; jle @X2greaterX1
  mov bx,X2; mov dx,Y2; cmp si,-1; mov si,140h; je @XNeg; jmp @XContinue
 @X2greaterX1:
  mov bx,X1; mov dx,Y1; cmp si,-1; mov si,140h; jne @XNeg; jmp @XContinue
 @XNeg:
  neg si
 @XContinue:
  mov di,bx; xchg dh,dl; add di,dx; shr dx,1; shr dx,1; add di,dx
  mov sp,cx; sub sp,ax; shl sp,1; mov bx,cx; shl bx,1; mov OffS,si
  mov si,bx; sub bx,ax; mov cx,ax; mov es,ScrBase; mov ah,Color; inc cx
 @XRunLoop:
  mov es:[di],ah; inc di; cmp bx,0; jl @XNoInc; add bx,sp; add di,OffS; jmp @XCheck
 @XNoInc:
  add bx,si
 @XCheck:
  loop @XRunLoop
 @Exit:
end;

{----------------------------------------------------------------------------}

procedure Init;

var
  x,y,z : integer; i : word;

begin
  mx:=100;
  my:=100;
  mz:=100;

  POINTS_BEFORE[0]:=mx;
  POINTS_BEFORE[1]:=my;
  POINTS_BEFORE[2]:=mz;

  POINTS_BEFORE[3]:=mx+200;
  POINTS_BEFORE[4]:=my;
  POINTS_BEFORE[5]:=mz;

  POINTS_BEFORE[6]:=mx+200;
  POINTS_BEFORE[7]:=my+200;
  POINTS_BEFORE[8]:=mz+0;

  POINTS_BEFORE[9]:=mx+0;
  POINTS_BEFORE[10]:=my+200;
  POINTS_BEFORE[11]:=mz+0;


  POINTS_BEFORE[12]:=mx+0;
  POINTS_BEFORE[13]:=my+0;
  POINTS_BEFORE[14]:=mz+200;

  POINTS_BEFORE[15]:=mx+200;
  POINTS_BEFORE[16]:=my+0;
  POINTS_BEFORE[17]:=mz+200;

  POINTS_BEFORE[18]:=mx+200;
  POINTS_BEFORE[19]:=my+200;
  POINTS_BEFORE[20]:=mz+200;

  POINTS_BEFORE[21]:=mx+0;
  POINTS_BEFORE[22]:=my+200;
  POINTS_BEFORE[23]:=mz+200;


  {VECTOR PUNTEN}
  POINTS_BEFORE[24]:=mx;
  POINTS_BEFORE[25]:=my;
  POINTS_BEFORE[26]:=mz-20;

  point[0].x :=255;
  point[0].y :=0;
  point[0].z :=0;
  point[1].x :=0;
  point[1].y :=255;
  point[1].z :=0;
  point[2].x :=0;
  point[2].y :=0;
  point[2].z :=255;

  for I := 1 to 63 do begin
    port[$3C8] := I;
    x:=I;
    if x>63 then x:=63;
    port[$3C9] := x;
    port[$3C9] := x;
    port[$3C9] := x;
  end;
   port[$3C8] := 64;
  port[$3C9] := 48;
  port[$3C9] := 0;
  port[$3C9] := 0;
   port[$3C8] := 65;
  port[$3C9] := 63;
  port[$3C9] := 32;
  port[$3C9] := 32;

   port[$3C8] := 66;
  port[$3C9] := 0;
  port[$3C9] := 48;
  port[$3C9] := 0;
   port[$3C8] := 67;
  port[$3C9] := 32;
  port[$3C9] := 63;
  port[$3C9] := 32;

   port[$3C8] := 68;
  port[$3C9] := 0;
  port[$3C9] := 0;
  port[$3C9] := 48;
   port[$3C8] := 69;
  port[$3C9] := 32;
  port[$3C9] := 32;
  port[$3C9] := 63;


  for i:=0 to 2047 do SinTab[i]:=trunc(SIN(i/1024*pi)*128);
end;

procedure Rotate;       {BEREKEN DE 3D-VECTOREN VOOR DE X,Y EN Z , GA NIET LANGS START}
var
  KEY:integer;
  Xstep : integer;
  Ystep : integer;
  Zstep : integer;
  VectIndicX,VectIndicY:integer;
  LoodVectX,LoodVectY:integer;
  LoodVectX_GoNeg,LoodVectY_GoNeg:integer;
  VectPythagorasXY:integer;
  sinr:integer;
  angle1:longint;
  MinX,MinY:integer;
begin
  PhiX := 40; PhiY := 70; PhiZ := 20;
  PhiX := trunc(-80*2048/360); PhiY := trunc(-10*2048/360); PhiZ := 0;
  PhiX :=-11001;PhiY:=6992;Phiz:=185;
  Xstep:=0;Ystep:=0;Zstep:=0;
  eyedistZ:=150*4;
  mx:=200;
  my:=200;
  mz:=200;
  repeat
    while (port[$3da] and 8) <> 8 do;
    while (port[$3da] and 8) = 8 do;
{    port[$3c8] := 0; port[$3c9] := 20; port[$3c9] := 0; port[$3c9] := 0;}

    color:=0;
    {REMOVE TEXTURE-INDICATION LINES}
      IF (ABS(LoodVectX)>ABS(LoodVectY)) AND (MinX>=-160) AND (MinX<160) then begin
        line(160+MinX,0,160+MinX,199);
        line(POINTS_AFTER2D[0]+160,POINTS_AFTER2D[1]+100,MinX+160,POINTS_AFTER2D[2]+100);
      end;
      IF (ABS(LoodVectX)<=ABS(LoodVectY)) AND(MinY>=-100) AND (MinY<100) then begin
        line(0,100+MinY,319,100+MinY);
      end;
    {REMOVE CUBE}
      line(POINTS_AFTER2D[0]+160,POINTS_AFTER2D[1]+100,POINTS_AFTER2D[3]+160,POINTS_AFTER2D[4]+100);
      line(POINTS_AFTER2D[3]+160,POINTS_AFTER2D[4]+100,POINTS_AFTER2D[6]+160,POINTS_AFTER2D[7]+100);
      line(POINTS_AFTER2D[6]+160,POINTS_AFTER2D[7]+100,POINTS_AFTER2D[9]+160,POINTS_AFTER2D[10]+100);
      line(POINTS_AFTER2D[9]+160,POINTS_AFTER2D[10]+100,POINTS_AFTER2D[0]+160,POINTS_AFTER2D[1]+100);

      line(POINTS_AFTER2D[12]+160,POINTS_AFTER2D[13]+100,POINTS_AFTER2D[15]+160,POINTS_AFTER2D[16]+100);
      line(POINTS_AFTER2D[15]+160,POINTS_AFTER2D[16]+100,POINTS_AFTER2D[18]+160,POINTS_AFTER2D[19]+100);
      line(POINTS_AFTER2D[18]+160,POINTS_AFTER2D[19]+100,POINTS_AFTER2D[21]+160,POINTS_AFTER2D[22]+100);
      line(POINTS_AFTER2D[21]+160,POINTS_AFTER2D[22]+100,POINTS_AFTER2D[12]+160,POINTS_AFTER2D[13]+100);

      line(POINTS_AFTER2D[0]+160,POINTS_AFTER2D[1]+100,POINTS_AFTER2D[12]+160,POINTS_AFTER2D[13]+100);
      line(POINTS_AFTER2D[3]+160,POINTS_AFTER2D[4]+100,POINTS_AFTER2D[15]+160,POINTS_AFTER2D[16]+100);
      line(POINTS_AFTER2D[6]+160,POINTS_AFTER2D[7]+100,POINTS_AFTER2D[18]+160,POINTS_AFTER2D[19]+100);
      line(POINTS_AFTER2D[9]+160,POINTS_AFTER2D[10]+100,POINTS_AFTER2D[21]+160,POINTS_AFTER2D[22]+100);

      line(POINTS_AFTER2D[0]+160,POINTS_AFTER2D[1]+100,POINTS_AFTER2D[24]+160,POINTS_AFTER2D[25]+100);

      line(287,99,287+VectIndicX DIV 8,99+VectIndicY DIV 8);
      line(287,99,287+LoodVectX_GoNeg DIV 8,99+LoodVectY_GoNeg DIV 8);

{CALCULATE BAS-POINTS}
    for I := 0 to NofPoints do begin
      color:=0;
      if (Xp[I] < 320) and (Yp[I] < 200) then
      begin
        line(287,33,Xp[i],Yp[i]);
      end;
      X1 := (Cosin(PhiY)*Point[I].X-Sinus(PhiY)*Point[I].Z) div 128;
      Y1 := (Cosin(PhiZ)*Point[I].Y-Sinus(PhiZ)*X1) div 128;
      Z1 := (Cosin(PhiY)*Point[I].Z+Sinus(PhiY)*Point[I].X) div 128;
      X  := (Cosin(PhiZ)*X1+Sinus(PhiZ)*Point[I].Y) div 128;
      Y  := (Cosin(PhiX)*Y1+Sinus(PhiX)*Z1) div 128;
      Z  := (Cosin(PhiX)*Z1-Sinus(PhiX)*Y1) div 128;
      if i=0 then begin
        XROT_X:=X;
        XROT_Y:=Y;
        XROT_Z:=Z;
      end;
      if i=1 then begin
        YROT_X:=X;
        YROT_Y:=Y;
        YROT_Z:=Z;
      end;
      if i=2 then begin
        ZROT_X:=X;
        ZROT_Y:=Y;
        ZROT_Z:=Z;
      end;
      Xp[I] := 287+(Xc*Z-X*Zc) div ((Z-400-Zc)*3);
      Yp[I] :=  33+(Yc*Z-Y*Zc) div ((Z-400-Zc)*3);
      if (Xp[I] < 320) and (Yp[I] < 200) then
      begin
        color:=64+i*2+(Z+300) DIV 300; {Z=-200 ,Z+200=200 ; Z=200 , Z+200=400}
        line(287,33,Xp[i],Yp[i]);
      end;
    end;
    inc(PhiX,Xstep);
    inc(PhiY,Ystep);
    inc(PhiZ,Zstep);

{SET MARK-POINTS}
    calcpoints(0,12);

    color:=65;
      line(POINTS_AFTER2D[0]+160,POINTS_AFTER2D[1]+100,POINTS_AFTER2D[3]+160,POINTS_AFTER2D[4]+100);
      line(POINTS_AFTER2D[3]+160,POINTS_AFTER2D[4]+100,POINTS_AFTER2D[6]+160,POINTS_AFTER2D[7]+100);
      line(POINTS_AFTER2D[6]+160,POINTS_AFTER2D[7]+100,POINTS_AFTER2D[9]+160,POINTS_AFTER2D[10]+100);
      line(POINTS_AFTER2D[9]+160,POINTS_AFTER2D[10]+100,POINTS_AFTER2D[0]+160,POINTS_AFTER2D[1]+100);
    color:=64;

      line(POINTS_AFTER2D[12]+160,POINTS_AFTER2D[13]+100,POINTS_AFTER2D[15]+160,POINTS_AFTER2D[16]+100);
      line(POINTS_AFTER2D[15]+160,POINTS_AFTER2D[16]+100,POINTS_AFTER2D[18]+160,POINTS_AFTER2D[19]+100);
      line(POINTS_AFTER2D[18]+160,POINTS_AFTER2D[19]+100,POINTS_AFTER2D[21]+160,POINTS_AFTER2D[22]+100);
      line(POINTS_AFTER2D[21]+160,POINTS_AFTER2D[22]+100,POINTS_AFTER2D[12]+160,POINTS_AFTER2D[13]+100);

      line(POINTS_AFTER2D[0]+160,POINTS_AFTER2D[1]+100,POINTS_AFTER2D[12]+160,POINTS_AFTER2D[13]+100);
      line(POINTS_AFTER2D[3]+160,POINTS_AFTER2D[4]+100,POINTS_AFTER2D[15]+160,POINTS_AFTER2D[16]+100);
      line(POINTS_AFTER2D[6]+160,POINTS_AFTER2D[7]+100,POINTS_AFTER2D[18]+160,POINTS_AFTER2D[19]+100);
      line(POINTS_AFTER2D[9]+160,POINTS_AFTER2D[10]+100,POINTS_AFTER2D[21]+160,POINTS_AFTER2D[22]+100);

      line(POINTS_AFTER2D[0]+160,POINTS_AFTER2D[1]+100,POINTS_AFTER2D[24]+160,POINTS_AFTER2D[25]+100);


{    port[$3c8] :=0; port[$3c9] :=32; port[$3c9] := 0; port[$3c9] := 0;}
      VectIndicX:=(POINTS_AFTER3D[24]-POINTS_AFTER3D[0]) DIV 64;
      VectIndicY:=(POINTS_AFTER3D[25]-POINTS_AFTER3D[1]) DIV 64;
      if (VectIndicX<>0) OR (VectIndicY<>0) then begin
      VectPythagorasXY:=trunc(SQRT(VectIndicX*VectIndicX+VectIndicY*VectIndicY));
      VectIndicX:=(VectIndicX*160) DIV VectPythagorasXY;
      VectIndicY:=(VectIndicY*160) DIV VectPythagorasXY;
      end else begin
      VectIndicX:=0;
      VectIndicY:=0;
      end;
      LoodVectX:=VectIndicY;
      LoodVectY:=-VectIndicX;

{BEREKEN HOEK ALPHA}
(*
      angle1:=-3200;
      sinr:=(VectIndicY*127) div 160;
      for i:=0 to 2047 do begin
        if (I AND 7)=0 then begin
          mem[ $a000:i shr 3+((SinTab[i]+125) shr 1)*320]  :=10{((SinTab[i]+128) DIV 4)+64};
          mem[ $a000:i shr 3+((SinTab[i]+127) shr 1)*320]  :=17{((SinTab[i]+128) DIV 4)+64};
          mem[ $a000:i shr 3+((SinTab[i]+129) shr 1)*320]  :=20{((SinTab[i]+128) DIV 4)+64};
          mem[ $a000:i shr 3+((SinTab[i]+131) shr 1)*320]  :=17{((SinTab[i]+128) DIV 4)+64};
          mem[ $a000:i shr 3+((SinTab[i]+133) shr 1)*320]  :=10{((SinTab[i]+128) DIV 4)+64};
        end;
        if sinr=SinTab[i] then begin
          angle1:=i;
          mem[$a000:i shr 3+((SinTab[i]+129) shr 1)*320]:=63;
        end;
      end;
*)

{deltaX>DeltaY-> ALPHA=0-44 V ALPHA=136-179 }
      color:=66;
      IF ABS(LoodVectX)>ABS(LoodVectY) then begin
        MinX:=POINTS_AFTER2D[0];
        if MinX>POINTS_AFTER2D[3] THEN MinX:=POINTS_AFTER2D[3];
        if MinX>POINTS_AFTER2D[6] THEN MinX:=POINTS_AFTER2D[6];
        if MinX>POINTS_AFTER2D[9] THEN MinX:=POINTS_AFTER2D[9];
        IF (MinX>=-160) AND (MinX<160) then line(160+MinX,0,160+MinX,199);
        If LoodVectX>0 THEN begin
          LoodVectX_GoNeg:=-LoodVectX;
          LoodVectY_GoNeg:=-LoodVectY;
        end;
        If LoodVectX<=0 THEN begin
          LoodVectX_GoNeg:=LoodVectX;
          LoodVectY_GoNeg:=LoodVectY;
        end;
      end;

      color:=66;
      IF ABS(LoodVectX)<=ABS(LoodVectY) then begin
        MinY:=POINTS_AFTER2D[1];
        if MinY>POINTS_AFTER2D[4] THEN MinY:=POINTS_AFTER2D[4];
        if MinY>POINTS_AFTER2D[7] THEN MinY:=POINTS_AFTER2D[7];
        if MinY>POINTS_AFTER2D[10] THEN MinY:=POINTS_AFTER2D[10];
        IF (MinY>=-100) AND (MinY<100) then line(0,100+MinY,319,100+MinY);
        If LoodVectY>0 THEN begin
          LoodVectX_GoNeg:=-LoodVectX;
          LoodVectY_GoNeg:=-LoodVectY;
        end;
        If LoodVectY<=0 THEN begin
          LoodVectX_GoNeg:=LoodVectX;
          LoodVectY_GoNeg:=LoodVectY;
        end;
      end;

      color:=64;
      line(287,99,287+VectIndicX DIV 8,99+VectIndicY DIV 8);
      color:=32;
      line(287,99,287+LoodVectX_GoNeg DIV 8,99+LoodVectY_GoNeg DIV 8);

      color:=68;

      IF ABS(LoodVectX)>ABS(LoodVectY) then begin
        POINTS_AFTER2D[2]:=POINTS_AFTER2D[1]+(LoodVectY_GoNeg*(POINTS_AFTER2D[0]-MinX)) DIV 160;
        line(POINTS_AFTER2D[0]+160,POINTS_AFTER2D[1]+100,MinX+160,POINTS_AFTER2D[2]+100);
      end;
{     GOTOXY(1,1);
      writeln('Angle:',(angle1*360) DIV 2048,'   ');
      writeln('YVector:',sinr,'   ');}

    port[$3c8] := 0; port[$3c9] := 0; port[$3c9] := 0; port[$3c9] := 0;
    key:=-1;
    if keypressed then KEY:=ord(readkey);
    if KEY=75 then dec(Ystep,1);
    if KEY=77 then inc(Ystep,1);
    if KEY=72 then dec(Xstep,1);
    if KEY=80 then inc(Xstep,1);
    if KEY=71 then dec(Zstep,1);
    if KEY=73 then inc(Zstep,1);
    if KEY=32 then begin
      Xstep:=0; Ystep:=0; Zstep:=0;
    end;
  until key=27;
end;
begin
  SetGraphics;
  Init;
  Rotate;
end.
