{
  Werkt alleen in Real Mode..

  Changing the stack is not possible in PROTECTED MODE, with
  mov ss:[bp+18] ,tried Push and Pop -> Runtime error 216 :(

}
program timerz;
uses crt,dos;

var
  getcs:word;
  getofs:word;
  getcs2:word;
  getofs2:word;
  getsp1,getsp2:word;
  compare:word;
  threadcs:word;
  threadip:word;
{
MA>generate an interrupt (int $70?) 1000 times a second.

To speed up the system timer by a factor of 2, call "goosetimer(2)":
}
procedure goosetimer(goose: byte);    { Speed up system timer }
var gooseword: word;
begin
  gooseword := $ffff div goose;       { Number of oscillations between ticks }
  port[$43] := $36;                   { Set timer at new speed }
  port[$40] := lo(gooseword);
  port[$40] := hi(gooseword);
end;
{
In that procedure, you are telling the timer chip how many chip oscillations
to wait before generating a "tick".  The default is to generate a "tick"
every 65536 cycles, or 18.2 times per second (which also works out to 65536
"ticks" per hour).  The drawback here is that the system clock will speed up
accordingly, as will all functions dependent on the reception of "ticks".
So a useful approach is to reprogram Int $08 such that additional "ticks"
are not passed along to the standard system functions.  The way to
accomplish that is to generate an "End of Interrupt" command on all the
additional "ticks" instead of invoking the "original" Int 08h ISR.  The
"End of Interrupt" command is a command that, much like the STI instruction,
enables subsequent hardware interrupts to be processed.  Code is in order:
}
var goosefactor, ticklooper, cloktick: byte;
    oldtimint: procedure;

{ GOOSEFACTOR: the multiplication factor for the system speed
  TICKLOOPER:  loops from 0 to GOOSEFACTOR - 1, resetting itself to 0
               when it gets to GOOSEFACTOR -- used internally to determine
               which "ticks" get passed along
  CLOKTICK:    counts "ticks"; used in standardizing program timing
  OLDTIMINT:   points to "original" Int 08h ISR }
{--------------------------------------------------------------------------}
procedure tickwait(time2wait:byte);
begin                                   { certain value }
  asm
    mov ax,BP
    mov getofs2,ax
    mov ax,SS
    mov getcs2,ax
{   mov bx,sp
    mov getsp1,sp}
    @loop:
    mov al,time2wait
    mov ah,cloktick
    cmp al,ah
    jle @quit
    jmp @loop
    @quit:
    mov al,0
    mov cloktick,al
  end;
{ repeat until cloktick >= time2wait;
    asm
      mov ax,ss
      mov getsp1,ax
    end;
    cloktick := 0;                        { reset counter }
{ end;}
end;
procedure alternative(time2wait:byte);
begin
  asm
    mov ax,OFFSET(@goal)
    mov threadip,ax
    mov ax,SEG(@goal)
    mov threadcs,ax
    @goal:
  end;
  writeln('Thread 2!');
end;

{--------------------------------------------------------------------------}
{(Flags,CS,IP,AX,BX,CX,DX,SI,DI,DS,ES,BP:word);}
var
  R_Flags,R_CS,R_IP,R_AX,R_BX,R_CX,R_DX,R_SI,R_DI,R_DS,R_ES,R_BP:word;
  Rights:word;
procedure newtimint; interrupt;   { new timer interrupt }
begin

  asm
(*  mov ax,ss:[bp-4]     {contains the cs interrupted from}
    mov getcs,ax
    mov ax,ss:[bp-6]     {contains the ofs interrupted from}
    mov getofs,ax*)
    mov ax,ss:[bp+16]    {contains the old ax}
    mov ax,ss:[bp+14]    {contains the old bx}
    mov ax,ss:[bp+12]    {contains the old cx}
    mov ax,ss:[bp+10]    {contains the old dx}
    mov ax,ss:[bp+8]    {contains the old si}
    mov ax,ss:[bp+6]    {contains the old di}
    mov ax,ss:[bp+4]    {contains the old ds}
    mov ax,ss:[bp+2]    {contains the old ??}
    mov ax,ss:[bp]      {contains the old sp}

{   mov ax,threadip
    mov ss:[bp+18],ax
    mov ax,threadcs
    mov ss:[bp+20],ax}

    pop R_BP
    pop R_ES
    pop R_DS
    pop R_DI
    pop R_SI
    pop R_DX
    pop R_CX
    pop R_BX
    pop R_AX
    pop R_IP
    pop R_CS
    pop R_Flags

{   mov ax,threadip
    mov R_IP,ax
    mov ax,threadcs
    mov R_CS,ax}

    mov ax,BP
    mov getofs,ax
    mov ax,SS
    mov getcs,ax

    push R_Flags
    push R_CS
    push R_IP
    push R_AX
    push R_BX
    push R_CX
    push R_DX
    push R_SI
    push R_DI
    push R_DS
    push R_ES
    push R_BP
  end;
{ CS:=threadcs;
  IP:=threadip;}

  if ticklooper > 0 then          { "suppress" this "tick" }
    port[$20] := $20              { "End-of-Interrupt" command }
   else begin
    asm pushf; end;               { call old timer interrupt }
    oldtimint;
  end;
  inc(cloktick);                  { update "tick" counter }
  inc(ticklooper);
  if ticklooper = goosefactor then ticklooper := 0;
end;
{--------------------------------------------------------------------------}
procedure initnewtimint(goose: byte); { set up new timer interrupt }
var gooseword: word;
begin
  goosetimer(goose);                  { speed up timer }
  goosefactor := goose;               { record speed increase }
  getintvec($08, @oldtimint);         { record location of old interrupt }
  setintvec($08, @newtimint);         { install new interrupt procedure }
  cloktick := 0;                      { set counter to 0 }
  ticklooper := 0;                    { set "extra tick" determiner to 0 }
  end;
{--------------------------------------------------------------------------}
procedure setoldtimint;               { reset old timer }
begin
  setintvec($08, @oldtimint);         { original interrupt }
  goosetimer(1);                      { original system speed }
  end;
{--------------------------------------------------------------------------}
{
To start new system timing, it's "initnewtimint"; to turn it off, it's
"setoldtimint".  Most of the rest of that code is "internal": you don't need
to worry about it.  The one procedure I haven't explained is "tickwait": it
is used to standardize timing in programs from machine to machine by waiting
for a given number of "ticks" to have gone by before continuing.  (Unlike
"Delay", "tickwait" monitors an interrupt-driven counter, meaning the number
of "ticks" is advanced even while other routines are executing.)  For
example, this loop will print a new line every 18 "ticks", which are coming
at twice the normal speed:
}
begin
  writeln;
  alternative(1);
  initnewtimint(1); {1-> 65536pulses/3600sec is 12.8Hz}

  cloktick := 0;
  while not keypressed do begin
{   writeln('getofs:',getofs,' cs:',getcs);
    writeln('getofs2:',getofs2,' cs2:',getcs2);
    writeln('Thread 1');
    tickwait(18);}
  end;
  setoldtimint;
end.
