program DEMO;
uses crt,dos,graph;

{alles met hor. -> horizontale lijnen}
{alles met ver. -> vertikale   lijnen}

var
{200 lijnen *
aant clippings nr. + (15 clippings in totaal * 2 coordinaten) }
  clipping_hor : array [0..(200*16*2)-1] of word;

{320 lijnen *
aant clippings nr. + (15 clippings in totaal * 2 coordinaten) }
  clipping_ver : array [0..(320*16*2)-1] of word;

  lijn_berekenbuffer : array [0..8000] of word;
  berekenbuffer_offset : word;
  berekenbufferoffsets : array [0..5] of word;
  berekenbufferlengte  : array [0..5] of word;
  berekenbufferfirst  : array [0..5] of word;
  CH:byte; {een ordinale CHAR}
  clipx1:word;
  wallx1:integer;
  wallx2:integer;

  myseg,myofs:word;
  assembler_aantalloop:word;
  assembler_Yspeedlong:longint;
  assembler_Ystart,assembler_Yspeed:word;
  assembler_YstartPREC,assembler_YspeedPREC:word;
{----------------------------------------------------------------------------}
procedure retrace; assembler; asm
  mov dx,3dah; @vert1: in al,dx; test al,8; jz @vert1
  @vert2: in al,dx; test al,8; jnz @vert2; end;

procedure reset_clipping_buffers;
var
  loc_cntr:word;
begin
  for loc_cntr:=0 to 199 do begin
    clipping_hor[loc_cntr*32]:=1;       { aantal clippings :=1 }
    clipping_hor[loc_cntr*32+2]:=0;     { X1:=0   }
    clipping_hor[loc_cntr*32+3]:=319;   { X2:=319 }
  end;
  for loc_cntr:=0 to 319 do begin
    clipping_ver[loc_cntr*32]:=1;       { aantal clippings :=1 }
    clipping_ver[loc_cntr*32+2]:=0;     { X1:=0   }
    clipping_ver[loc_cntr*32+3]:=199;   { X2:=199 }
  end;
end;

procedure indicate_clippings_hor;
var
  loc_cntr:word;
  loc_cntr2:word;
  loc_cntr3:word;
  loc_coord1,loc_coord2:word;
  loc_aantal_clippings:word;
begin
  for loc_cntr:=0 to 199 do begin
    loc_aantal_clippings:=clipping_hor[loc_cntr*32];
    for loc_cntr2:=0 to loc_aantal_clippings-1 do begin
      loc_coord1:=clipping_hor[loc_cntr*32+2+loc_cntr2*2];
      loc_coord2:=clipping_hor[loc_cntr*32+3+loc_cntr2*2];
      for loc_cntr3:=loc_coord1 to loc_coord2 do begin
        mem[$a000:loc_cntr*320+loc_cntr3]:=loc_cntr2+128;
      end;
    end;
  end;
end;
{----------------------------------------------------------------------------}
procedure indicate_clippings_ver;
var
  loc_cntr:word;
  loc_cntr2:word;
  loc_cntr3:word;
  loc_coord1,loc_coord2:word;
  loc_aantal_clippings:word;
begin
  for loc_cntr:=0 to 319 do begin
    loc_aantal_clippings:=clipping_ver[loc_cntr*32];
    for loc_cntr2:=0 to loc_aantal_clippings-1 do begin
      loc_coord1:=clipping_ver[loc_cntr*32+2+loc_cntr2*2];
      loc_coord2:=clipping_ver[loc_cntr*32+3+loc_cntr2*2];
      for loc_cntr3:=loc_coord1 to loc_coord2 do begin
        mem[$a000:loc_cntr+loc_cntr3*320]:=loc_cntr2+128;
      end;
    end;
  end;
end;
procedure berekenlijn_asm;
begin
{
            cx : de word counter.
loc_YspeedPREC : de byte die bij bx opgeteld wordt.
            bx : de byte die een carry kan veroorzaken  -> 1/256e Y.
            ax : de word die bij dx opgeteld wordt.
            dx : de word ,die geldt als integer waarde Y.
}
  asm
    mov ax,myseg
    mov es,ax
    mov di,berekenbuffer_offset
    shl di,1
    add di,myofs
    mov cx,assembler_aantalloop
    mov dx,assembler_Ystart
    mov bx,assembler_YstartPREC
    mov ax,assembler_Yspeed
@looplab:
    add bx,assembler_YspeedPREC
    adc dx,ax
    mov es:[di],dx
    add di,2
    LOOP @looplab
    sub di,myofs
    shr di,1
    mov berekenbuffer_offset,di
  end;
end;
procedure berekenrechtelijn_asm;
begin
{
            cx : de word counter.
loc_YspeedPREC : de byte die bij bx opgeteld wordt.
            dx : de word ,die geldt als integer waarde Y.
}
  asm
    mov ax,myseg
    mov es,ax
    mov di,berekenbuffer_offset
    shl di,1
    add di,myofs
    mov cx,assembler_aantalloop
    mov dx,assembler_Ystart
@looplab:
    mov es:[di],dx
    add di,2
    LOOP @looplab
    sub di,myofs
    shr di,1
    mov berekenbuffer_offset,di
  end;
end;


procedure bereken_lijn_wall(loc_X1,loc_Y11,loc_Y12,loc_X2,loc_Y21,loc_Y22,loc_clipX1,loc_clipX2:longint);
var
  loc_X1clipped:word;
  loc_X2clipped:word;
  loc_cntr,loc_cntr2:word;
{ diff:word;}
  value:word;
  loc_aantal_clippings:word;
  loc_coord1toremove,loc_coord2toremove:integer;
  loc_coord1,loc_coord2:integer;
begin
  loc_X1clipped:=loc_clipX1;
  if loc_clipX1<loc_X1 then loc_X1clipped:=loc_X1;
  loc_X2clipped:=loc_clipX2;
  if loc_clipX2>loc_X2 then loc_X2clipped:=loc_X2;

  {begin aan array berekenbuffer}
  berekenbuffer_offset:=0;

  {bereken handle1 en handle2}
  berekenbufferoffsets[0]:=berekenbuffer_offset;
  berekenbufferfirst[0]:=loc_X1clipped;
  myseg:=SEG(lijn_berekenbuffer);
  myofs:=OFS(lijn_berekenbuffer);
  assembler_aantalloop:=loc_X2clipped-loc_X1clipped;
  assembler_Ystart:=loc_Y11;
  assembler_YstartPREC:=0;
  assembler_Yspeedlong:=trunc(65536*(loc_Y21-loc_Y11)/(loc_X2-loc_X1));
  assembler_YspeedPREC:=assembler_Yspeedlong AND 65535;
  assembler_Yspeed:=(assembler_Yspeedlong-assembler_yspeedPREC) DIV 65536;
  berekenlijn_asm;

  berekenbufferoffsets[1]:=berekenbuffer_offset;
  berekenbufferfirst[1]:=loc_X1clipped;
  assembler_aantalloop:=loc_X2clipped-loc_X1clipped;
  assembler_Ystart:=loc_Y12;
  assembler_YstartPREC:=0;
  assembler_Yspeedlong:=trunc(65536*(loc_Y22-loc_Y12)/(loc_X2-loc_X1));
  assembler_YspeedPREC:=assembler_Yspeedlong AND 65535;
  assembler_Yspeed:=(assembler_Yspeedlong-assembler_yspeedPREC) DIV 65536;
  berekenlijn_asm;

  {bereken handle3}
  berekenbufferoffsets[2]:=berekenbuffer_offset;
  if loc_Y21>loc_Y11 then begin {links boven naar rechts onder}
    berekenbufferfirst[2]:=loc_Y11;
    assembler_aantalloop:=loc_Y21-loc_Y11;
    assembler_Ystart:=loc_X1;
    assembler_YstartPREC:=0;
    assembler_Yspeedlong:=trunc(65536*(loc_X2-loc_X1)/(loc_Y21-loc_Y11));
    assembler_YspeedPREC:=assembler_Yspeedlong AND 65535;
    assembler_Yspeed:=(assembler_Yspeedlong-assembler_yspeedPREC) DIV 65536;
    berekenlijn_asm;
  end;
  if loc_Y21<loc_Y11 then begin
    berekenbufferfirst[2]:=loc_Y21;
    assembler_aantalloop:=loc_Y11-loc_Y21;
    assembler_Ystart:=loc_X2;
    assembler_YstartPREC:=0;
    assembler_Yspeedlong:=trunc(65536*(loc_X2-loc_X1)/(loc_Y21-loc_Y11));
    assembler_YspeedPREC:=assembler_Yspeedlong AND 65535;
    assembler_Yspeed:=(assembler_Yspeedlong-assembler_yspeedPREC) DIV 65536;
    berekenlijn_asm;
  end;
  {bereken handle4}
  berekenbufferoffsets[3]:=berekenbuffer_offset;
  berekenbufferfirst[3]:=loc_Y21;
  assembler_aantalloop:=loc_Y22-loc_Y21;
  assembler_Ystart:=loc_X2;
  berekenrechtelijn_asm;

  {bereken handle5}
  berekenbufferoffsets[4]:=berekenbuffer_offset;
  if loc_Y22>loc_Y12 then begin
    berekenbufferfirst[4]:=loc_Y12;
    assembler_aantalloop:=loc_Y22-loc_Y12;
    assembler_Ystart:=loc_X1;
    assembler_YstartPREC:=0;
    assembler_Yspeedlong:=trunc(65536*(loc_X2-loc_X1)/(loc_Y22-loc_Y12));
    assembler_YspeedPREC:=assembler_Yspeedlong AND 65535;
    assembler_Yspeed:=(assembler_Yspeedlong-assembler_yspeedPREC) DIV 65536;
    berekenlijn_asm;
  end;
  if loc_Y21<loc_Y12 then begin
    berekenbufferfirst[4]:=loc_Y22;
    assembler_aantalloop:=loc_Y12-loc_Y22;
    assembler_Ystart:=loc_X2;
    assembler_YstartPREC:=0;
    assembler_Yspeedlong:=trunc(65536*(loc_X2-loc_X1)/(loc_Y22-loc_Y12));
    assembler_YspeedPREC:=assembler_Yspeedlong AND 65535;
    assembler_Yspeed:=(assembler_Yspeedlong-assembler_yspeedPREC) DIV 65536;
    berekenlijn_asm;
  end;
  {bereken handle6}
  berekenbufferoffsets[5]:=berekenbuffer_offset;
  berekenbufferfirst[5]:=loc_Y11;
  assembler_aantalloop:=loc_Y12-loc_Y11;
  assembler_Ystart:=loc_X1;
  berekenrechtelijn_asm;

  berekenbufferlengte[0]:=berekenbufferoffsets[1]-berekenbufferoffsets[0];
  berekenbufferlengte[1]:=berekenbufferoffsets[2]-berekenbufferoffsets[1];
  berekenbufferlengte[2]:=berekenbufferoffsets[3]-berekenbufferoffsets[2];
  berekenbufferlengte[3]:=berekenbufferoffsets[4]-berekenbufferoffsets[3];
  berekenbufferlengte[4]:=berekenbufferoffsets[5]-berekenbufferoffsets[4];
  berekenbufferlengte[5]:=berekenbuffer_offset   -berekenbufferoffsets[5];
{
  if berekenbufferlengte[0]<>0 then
  for loc_cntr:=0 to berekenbufferlengte[0]-1 do
      mem[$a000:loc_cntr+berekenbufferfirst[0]+lijn_berekenbuffer[berekenbufferoffsets[0]+loc_cntr]*320]:=2;
  if berekenbufferlengte[1]<>0 then
  for loc_cntr:=0 to berekenbufferlengte[1]-1 do
      mem[$a000:loc_cntr+berekenbufferfirst[1]+lijn_berekenbuffer[berekenbufferoffsets[1]+loc_cntr]*320]:=2;
  if berekenbufferlengte[2]<>0 then
}
  for loc_cntr:=0 to berekenbufferlengte[2]-1 do
      mem[$a000:loc_cntr*320+berekenbufferfirst[2]*320+lijn_berekenbuffer[berekenbufferoffsets[2]+loc_cntr]]:=3;
  if berekenbufferlengte[3]<>0 then
  for loc_cntr:=0 to berekenbufferlengte[3]-1 do
      mem[$a000:loc_cntr*320+berekenbufferfirst[3]*320+lijn_berekenbuffer[berekenbufferoffsets[3]+loc_cntr]]:=3;

  if berekenbufferlengte[4]<>0 then
  for loc_cntr:=0 to berekenbufferlengte[4]-1 do
      mem[$a000:loc_cntr*320+berekenbufferfirst[4]*320+lijn_berekenbuffer[berekenbufferoffsets[4]+loc_cntr]]:=4;
  if berekenbufferlengte[5]<>0 then
  for loc_cntr:=0 to berekenbufferlengte[5]-1 do
      mem[$a000:loc_cntr*320+berekenbufferfirst[5]*320+lijn_berekenbuffer[berekenbufferoffsets[5]+loc_cntr]]:=4;


  {de muur uit de vertikale clippings}
  for loc_cntr:=loc_X1clipped to loc_X2clipped do begin
    loc_coord1toremove:=lijn_berekenbuffer[berekenbufferoffsets[0]+loc_cntr];
    loc_coord2toremove:=lijn_berekenbuffer[berekenbufferoffsets[1]+loc_cntr];

    loc_aantal_clippings:=clipping_ver[loc_cntr*32];
    for loc_cntr2:=0 to loc_aantal_clippings-1 do begin
      loc_coord1:=clipping_ver[loc_cntr*32+2+loc_cntr2*2];
      loc_coord2:=clipping_ver[loc_cntr*32+3+loc_cntr2*2];
    end;
  end;
end;

procedure go_wall(loc_X1,loc_Y11,loc_Y12,loc_X2,loc_Y21,loc_Y22,loc_clipX1,loc_clipX2:longint);
begin
  bereken_lijn_wall(loc_X1,loc_Y11,loc_Y12,loc_X2,loc_Y21,loc_Y22,loc_clipX1,loc_clipX2);{COORDS}
end;
procedure draw_vr;
begin
  reset_clipping_buffers;
  go_wall(wallx1 DIV 256,0,80,wallx2 DIV 3,40,60,0,319);  {wall:X1,Y11,Y12,X2,Y21,Y22 Xclip:X1,X2}
end;
{----------------------------------------------------------------------------}
{----------------------------------------------------------------------------}
{----------------------------------------------------------------------------}

begin
  Asm Mov AX,13h; Int 10h end;  { Go_Grafix_Mode 320x200x256}
  DirectVideo:=False;           { WriteLn works in GrafiX mode Now }
  {HOOFDLUS}
  wallx1:=5*256;
  wallx2:=trunc(16.6*3);
  repeat
{    retrace;}
    port[$3c8]:=0;
    port[$3c9]:=0;
    port[$3c9]:=16;
    port[$3c9]:=0;
    inc(wallx1,-1);
    inc(wallx2);
    draw_vr;
    port[$3c8]:=0;
    port[$3c9]:=0;
    port[$3c9]:=0;
    port[$3c9]:=0;
{   indicate_clippings_ver;    {veel tijd nodig , dit is voor de programmeur}
    CH:=255;
    if keypressed then CH:=ORD(readkey);
  until CH=27;

  Asm Mov AX,3h; Int 10h end;  { Go_TextMode}
end.


{PROCEDURE FORM}
{
procedure ;
var
begin
end;
}
