Type
    TDmaBlock = record   { Big samples never stay in a Physical page }
      P1,P2   : Pointer; { So I split them Up, see below how.. }
      S1,S2   : Word;
      Played2 : Boolean;
    end;

{----------------------------------------------------------------------}
Var Sound     : Pointer;
    Size      : Word;
    Playing   : Boolean;
    OldIntVec : Pointer;  { Old IRQ 0Fh Pointer }
    IRQmask   : Byte;     { Store Interrupt Controler's status. Port $21 }
    IRQpassed : Boolean;     { A test value , not necesary}

{DMA}
    DMAblock  : TDMAblock;
    VOLTab    : array [1..256*64] of byte; {Volumes->256 waarden * 64 volumes}
    DMAblk1   : array [1..400] of byte;   {3 blocks,waarvan 2 worden}
    DMAblk2   : array [1..400] of byte;   {uitgekozen}
    DMAblk3   : array [1..400] of byte;   {deze hebben geen page-braking}
    OSCblk    : array [1..639] of byte;{1 blk voor de oude oscillator-waarden}
    RealDMAfreq: word;   { de frequentie teruggerekend vanuit TIME_CONSTANT}
    amp1,amp2:byte;
    count1,count2:word;
    SMPpointer: pointer;   { de pointer naar sample1}
    SMPlen    : word;      { de lengte v/d sample}
    SMPoff    : word;      { de positie v/d sample}
    SMPfreq   : word;      { de frequentie v/d sample af te spelen, tot 65kHz}
    DMA_Freq  : word;
{MUIS}
   mouse_k,mouse_x,mouse_y  : word;
   kleur : byte;
{FILTER}
   filter,filter2,filter3,filter4,filter5,filter6:integer;
   filtervalue:word;
   filtertype:word;
{HELEMAAL ONDERIN}
  retrace_found:word;
  SB_handler_done:boolean;
  Ch       : char;
  SegS,
  OfsS,
  BLeft,
  B_S2     : Word;
  NextPage : lONGiNT;
  dmablk1_avail,dmablk2_avail,dmablk3_avail,dmablk_nr:word;
  dmablk1_point,dmablk2_point,dmablk3_point:longint;

  time:word;
{---- Ports  -----------------------------------------------------------}
Const
   HighSpeedDMADAC   = $90;
   AutoInitDMADAC    = $1C;
   Mdebug : Boolean = False;
{  fname = 'D:\music\samples3\dixie.wav';  { Can be any raw data File }
{  fname = 'D:\music\samples\groove2.smp';  { Can be any raw data File }
{  fname = 'D:\music\samples2\goestofu.889';{}
{  fname = 'D:\music\samples2\ohnana.smp';  {}
{  fname = 'D:\music\samples2\samplesi.940';  {FILTER}
{  fname = 'D:\music\samples2\baselin3';  {FILTER}
{  fname = 'D:\music\samples2\dalcoura.smp'; {}
{  fname = 'D:\music\keybrds\breakb.wav';    {}
{  fname = 'D:\music\keybrds\hihaline.wav';  {}
{  fname = 'D:\music\keybrds\basslin2.wav';{}
{  fname = 'D:\music\sample2c\x957455x.083';{}
   fname = 'D:\music\sample2c\mdtockle.311';{}
{  fname = 'groove2.smp';  { Can be any raw data File }

   BASE       = $220;         { Change this to your card base adres and }
   Jumper     = $5;           { IRQ-setting of your SB (compatible)...  }
   SB_IRQ     = Jumper + $8;  { This will be the interrupt generated by SB }
   IRQ_Contr  = $21;          { IRQ controller 1 (IRQ-Jumper 2, 5, 7)
                                (Controller 2 (IRQ-Jumper 10 at Port $A1,
                                 Bit 2 see next item too but then also
                                 haveto enable IRQ 2 at Controller 1) }
   BitMask    = 32;          { Oh my god, how I'm gonna explain this one ?
                                Ok, here it is: You gotta enable the irq
                                on the IRQ controller. The Bits in the byte
                                tell wich IRQ to enable. So to enable a
                                hardware irq (jumper setting), set the
                                corresponding bit to Zero. I hope you know
                                how to do that...
                                   Bit: 7  6  5  4  3  2  1  0
                                        ^     ^        ^
                                     IRQ7  IRQ5     IRQ2 and IRQ10

                                 So For IRQ 10 > enable IRQ 2 (set bit 2 to
                                 zero) at Port $21, and enable IRQ 10 (set
                                 bit 2 to zero) at Port $A1. <pffff>
                                 Just look at the INIT procedure...   }


   resetport  = Base + $6;    { the SB_ports used }
   readport   = Base + $A;
   Writeport  = Base + $C;
   statusport = Base + $E;

   HexTable : Array[0..15] of Char =
       ('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');


{--  commands to WritePort ------------------------------------------}

   DAC_Write  = $10; { DIRECT 8-BIT DAC (Single Byte Data Transfer) }
   DMA_8BIT   = $14; { DMA MODE 8-BIT DAC }
   ADC_Read   = $20; { DIRECT MODE (Single Byte Data Transfer)}
   speakerON  = $D1;
   speakerOFF = $D3;

   DMACont    = $D4;
   DMAStop    = $D0; { Strange enough, send first to install IRQ somehow }
{----------------------------------------------------------------------}

Procedure WriteDSP(Value: Byte);
Begin
  repeat until (Port[WritePort] And $80)=0; { Until bit 7 is set }
  Port[WritePort] := value;
End;

{----------------------------------------------------------------------}

Function ResetDSP: Boolean;
var
  TimeDone : LongInt;

Begin
 TimeDone:=0;
 Port[ResetPort]:=1;          { Port $226 }
 Asm Nop;Nop;Nop; End;
 Port[ResetPort]:=0;
 Repeat
   Inc(TimeDone);             { I don't wanna stay here 4 ever }
 Until (TimeDone>123000) or (Port[ReadPort] = $AA);
 ResetDSP:=(TimeDone<123000); { exited with port-read instead by TimeDone }
End;

{----------------------------------------------------------------------}

Procedure SetFreq(frequency: Word); { Set DMA > DSP playback frequency }
Var TIME_CONSTANT : word;
Begin
  DMA_freq:=frequency;
  TIME_CONSTANT := 256 - 1000000 div frequency; { From da bookZ }
  WriteDSP($40);
  WriteDSP(TIME_CONSTANT);
  RealDMAFreq:=1000000 div (256-TIME_CONSTANT)
end;


{----------------------------------------------------------------------}

procedure SendDMA(sound : Pointer; size : word); { Send Sample Via DMA }
var page, offset : Word;
begin
  size := size - 1;

  { Set up the DMA chip }
  Offset := (Seg(sound^) Shl 4) + Ofs(sound^);      { 20-bit physical adres}
  page := (Seg(sound^) + Ofs(sound^) shr 4) shr 12; { Page 0..F }
  Port[$0A] := 5;              { Mask for Channel 1 }
  Port[$0C] := 0;              { Clear Flip-Flop ?? }
  Port[$0B] := $49;            { DMA > DAC mode. (ADC > DMA = $45) }
  Port[$02] := Lo(offset);     { Low Byte Base Offset Adress }
  Port[$02] := Hi(offset);     { High Byte Base Offset Adress }
  Port[$83] := page;           { Physical memory Page number }
  Port[$03] := Lo(size);       { Low Byte DMA Data Count }
  Port[$03] := Hi(size);       { High Byte DMA Data Count }
  Port[$0A] := 1;              { Enable DMA channel 1 }

  { Set the playback type (8-bit) }
  WriteDSP( DMA_8BIT );        { DMA > DAC 8-Bit mode }
  WriteDSP( Lo(size) );        { Low Byte DMA Data Count }
  Playing:=True;
  WriteDSP( Hi(size) );   { DSP Starts at High Byte Data Count recieved }
{  if Mdebug then begin GotoXY(30,11);Writeln('DMA > DAC '); end;}
  if DMA_Freq>22000 then  {TESTJE}
    WriteDSP(HighSpeedDMADAC)
  else
    WriteDSP(AutoInitDMADAC);

end;

{---------------------------------------------------------------------}

(*
procedure CalcDMA(sound : Pointer; size : word); { Calc DMA-Sample }
var
   adres_SEG_DMA : word;
   adres_OFS_DMA : word;
   adres_SEG_SMP1: word;
   adres_OFS_SMP1: word;
   adres_SEG_VOLTAB:word;
   adres_OFS_VOLTAB:word;
   ADRES:longint;
   cntr,cntr2:word;
begin
   adres_SEG_DMA :=SEG(Sound^);
   adres_OFS_DMA :=OFS(Sound^);
   adres_SEG_SMP1:=SEG(smppointer^);
   adres_OFS_SMP1:=OFS(smppointer^)+SMPoff;

   if SMPoff<SMPlen then begin
     for cntr:=0 to size-1 do begin
       filter2:=mem[adres_SEG_SMP1:adres_OFS_SMP1+cntr];
       if adres_OFS_SMP1+cntr>SMPlen then dec(adres_OFS_SMP1,SMPlen);
       mem[adres_SEG_DMA:adres_OFS_DMA+cntr]:=filter2;
     end;
     inc(SMPoff,(size*8 DIV 8));
{    if SMPoff>SMPlen then SMPoff:=SMPoff-SMPlen+80;}{LOOP!}
   end;
   IF SMPoff>=SMPlen then begin
     filter2:=128;
     for cntr:=0 to size-1 do begin
       mem[adres_SEG_DMA:adres_OFS_DMA+cntr]:=filter2;
     end;
   end;
end;
*)
{----------------------------------------------------------------------}
procedure retrace_sound; assembler; asm
{ mov ax,retrace_found
  mov retrace_found_prev,ax}


  mov retrace_found,65535 {niet gevonden}

  mov cx,800 {1000}
  mov dx,3dah;
@vert1:
  dec cx
  je @not_found
  in al,dx;
  test al,8;
  jz @vert1
@vert2:
  in al,dx;
  test al,8;
  jnz @vert2;
  mov retrace_found,cx
@not_found:
end;
Procedure SB_intHandler; Interrupt;    {TEST !!!!}
{     Ŀ
       IRQ Jumper   Interrupt 
        Setting     Generated 
      Ĵ
          2            0Ah    
          3            0Bh    
          5            0Dh    
          7            0Fh    
      }
var A : Byte;
Begin
  A:=Port[$22E]; {Acknowledge Interrupt from SB, to SB, by reading port $22E}
  inc(time);

  retrace_sound;
  if retrace_found=65535 then begin
    if DMAblock.Played2=false then DMAblock.S1:=300;{301}
    if DMAblock.Played2=true  then DMAblock.S2:=301;{300}
  end else begin
    if DMAblock.Played2=false then DMAblock.S1:=304;{303}
    if DMAblock.Played2=true  then DMAblock.S2:=304;{303}
  end;
{ if DMAblock.Played2=false then DMAblock.S1:=304;{301}
{ if DMAblock.Played2=true  then DMAblock.S2:=304;{300}
  if (DMAblock.Played2=false) then
   begin
     SendDMA(DMAblock.P2, DMAblock.S2);
     DMAblock.Played2 := True;
   end else
   begin
     SendDMA(DMAblock.P1, DMAblock.S1);
     DMAblock.Played2 := false;
  end;
  IRQpassed:=True;
  SB_handler_done:=true;
  Port[$20]:=$20; { EOI, End Of Interrupt to Interrupt Controller }
end;
{----------------------------------------------------------------------}
Procedure INIT;
Begin

 ResetDSP;
 Asm Cli End;
   IRQmask:=Port[IRQ_Contr];
   If IRQmask and BitMask = Bitmask then
      Port[IRQ_Contr]:=IRQmask Xor Bitmask; { Set bit to 0 to enable IRQ }
   PlayIng := False;
 Asm Sti End;
 WriteDSP(SpeakerON);
 SetFreq(16000);
 GetIntVec(sb_irq, OldIntVec);
 SetIntVec(sb_irq, @SB_IntHandler);
end;
{----------------------------------------------------------------------}
Procedure DONE;
Begin
 WriteDSP(SpeakerOFF);
 Asm Cli End;
 SetIntVec(SB_IRQ, OldIntVec);
 Port[IRQ_Contr]:=IRQmask; { Restore the mess, we made of it. }
 Asm Sti End;
end;
procedure Sound_quit;
begin
  FreeMem(Sound,Size); { Why should I, Runtime Lib does it, but OK }
  Done;  { Would ye rather be left hanging at some Nil-Vector ?? :-) }
end;

procedure Sound_init;
begin

{ Mdebug := True;               { Debug Mode Shows when DMA starts and IRQ}
{ DirectVideo:=False;           { WriteLn works in GrafiX mode Now }
  Init;

  With DMAblock do
  begin
    dmablk1_avail:=0;
    dmablk2_avail:=0;
    dmablk3_avail:=0;
    dmablk1_point:=SEG(dmablk1)*16+OFS(dmablk1);
    dmablk2_point:=SEG(dmablk2)*16+OFS(dmablk2);
    dmablk3_point:=SEG(dmablk3)*16+OFS(dmablk3);
    if (DMABLK1_point shr 16)=((DMABLK1_point+600) shr 16) then dmablk1_avail:=1;
    if (DMABLK2_point shr 16)=((DMABLK2_point+600) shr 16) then dmablk2_avail:=1;
    if (DMABLK3_point shr 16)=((DMABLK3_point+600) shr 16) then dmablk3_avail:=1;
    dmablk_nr:=0;

    S1:=300;
    S2:=301;
{
    S1:=256;
    S2:=256;
}
    if (dmablk1_avail=1) and (dmablk_nr=0) then begin
      dmablk1_avail:=0;
      dmablk_nr:=1;
      P1:=@DMABLK1;
    end;

    if (dmablk2_avail=1) and (dmablk_nr=0) then begin
      dmablk2_avail:=0;
      dmablk_nr:=1;
     P1:=@DMABLK2;
    end;

    if (dmablk3_avail=1) and (dmablk_nr=0) then begin
      dmablk3_avail:=0;
      dmablk_nr:=1;
      P1:=@DMABLK3;
    end;

    if (dmablk1_avail=1) and (dmablk_nr=1) then begin
      dmablk1_avail:=0;
      dmablk_nr:=2;
      P2:=@DMABLK1;
    end;

    if (dmablk2_avail=1) and (dmablk_nr=1) then begin
      dmablk2_avail:=0;
      dmablk_nr:=2;
      P2:=@DMABLK2;
    end;

    if (dmablk2_avail=1) and (dmablk_nr=1) then begin
      dmablk3_avail:=0;
      dmablk_nr:=2;
      P2:=@DMABLK3;
    end;

    count1:=0;
    count2:=130;
{   calcdma(P1,S1);
    calcdma(P2,S2);}

{ GOTOXY(1,4);
  WriteLn('The DMA-buffers:');
  GOTOXY(1,5);
  WriteLn('#1 Pointer: ',Hex(Seg(P1^)),':',Hex(Ofs(P1^)),'  Size : ',Hex(S1));
  WriteLn('#2 Pointer: ',Hex(Seg(P2^)),':',Hex(Ofs(P2^)),'  Size : ',Hex(S2));
{  WriteLn('S1 + S2 (Should be same as Size): ',Hex( S1 + S2),' (',((S1+S2)/1024):2:2,' Kb)');
  WriteLn('   --- Next Phys. Page (((SegS + OfsS shr 4) shr 12) +1) at: ',Hex_Int(NextPage));}
{ WriteLn;
  GOTOXY(1,8);
  WriteLn('DMAfreq : ',RealDMAfreq,'Hz');
  GotoXY(1,18);
  WriteLn('KEY INFO:');
  WriteLn('SpaceBar - Play Sample #1');
  WriteLn('Q        - DMAfreq at 16000 Hz');
  WriteLn('W        - DMAfreq at 21000 Hz'); {=ALT241}
{ WriteLn('Enter    - Stop DMA');
  WriteLn('Esc      - Quit');}
  end;
  IRQpassed:=False;{ Default : IRQ not passed! }

  {Activate DMA}
  SetFreq(21000);
  DMAblock.Played2 := False;         { Re-Init }
{ delay(3);}
  SendDMA(DMAblock.P1, DMAblock.S1); { Blast it out }

end;
